; -- TweetVoice.iss --

[Languages]
Name: "en"; MessagesFile: "compiler:Default.isl"
Name: "ja"; MessagesFile: "compiler:Languages\Japanese.isl"


[Setup]
AppName=TweetVoice
AppVerName=TweetVoice version 1.0.0 beta 4
DefaultDirName={pf}\TweetVoice
DefaultGroupName=TweetVoice
UninstallDisplayIcon={app}\bin\TweetVoice.exe
Compression=lzma
SolidCompression=yes
OutputDir=Output
OutputBaseFilename=TweetVoice1.0.0Beta4-ja

[Files]
Source: "..\bin\Release\*.*"; DestDir: "{app}\bin"; Flags: ignoreversion
Source: "..\Dic\*.*"; DestDir: "{app}\Dic"
Source: "..\Docs\Readme.txt"; DestDir: "{app}\Docs"; Flags: isreadme
Source: "..\Docs\*.txt"; DestDir: "{app}\Docs"
Source: "..\SSL\readme.txt"; DestDir: "{app}\Docs\OpenSSL"

[Icons]
Name: "{group}\TweetVoice"; Filename: "{app}\bin\TweetVoice.exe"
Name: "{group}\Read me"; Filename: "{app}\Docs\Readme.txt"
Name: "{userdesktop}\TweetVoice"; Filename: "{app}\bin\TweetVoice.exe"; Tasks: desktopicon

[Tasks]
Name: desktopicon; Description: "{cm:CreateDesktopIcon}" ; GroupDescription: {cm:AdditionalIcons}

[Run]
Filename: "{app}\bin\TweetVoice.exe"; Description: "{cm:LaunchProgram,TweetVoice}"; Flags: postinstall nowait skipifsilent











