unit tvFormMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, ComCtrls, Menus, ToolWin, Buttons, Tabs, tvXMLBase, VirtualTrees, ExtCtrls,
  tvImageDownloader, tvCommunicator, tvSpeechThread, Generics.Collections, DateUtils, utFunctions, ActnList,
  tvRectView, ImgList, tvXMLStatusesTab, pngimage, XPMan, Clipbrd, PerlRegEx, tvURLShortener, StrUtils;

type
  TFormMainTweetVoice = class(TForm)
    MainMenu: TMainMenu;
    StatusBar: TStatusBar;
    menuItemTool: TMenuItem;
    menuItemToolOptions: TMenuItem;
    PanelPost: TPanel;
    LabelLeftCharCount: TLabel;
    ButtonPost: TButton;
    Timer: TTimer;
    menuItemSpeech: TMenuItem;
    menuItemPauseSpeech: TMenuItem;
    menuItemSpeak: TMenuItem;
    ActionList: TActionList;
    ActionSpeak: TAction;
    PopupMenuTreeView: TPopupMenu;
    popMenuItemSpeakOne: TMenuItem;
    popMenuItemPauseSpeech: TMenuItem;
    TrayIcon: TTrayIcon;
    TimerBlink: TTimer;
    menuItemView: TMenuItem;
    menuItemViewRefresh: TMenuItem;
    N1: TMenuItem;
    menuShowFormUsers: TMenuItem;
    ActionShowFormUsers: TAction;
    ActionRefresh: TAction;
    ActionOpenWebTwitterHome: TAction;
    ActionOpenWebHP: TAction;
    popMenuItemSpeak: TMenuItem;
    popMenuItemOpenWeb: TMenuItem;
    popMenuItemOpenWebTwitterHome: TMenuItem;
    popMenuItemOpenWebHP: TMenuItem;
    ActionShowFormUserOptions: TAction;
    popMenuItemUser: TMenuItem;
    popMenuItemShowFormUserOptions: TMenuItem;
    ActionFormLogs: TAction;
    menuItemShowFormLogs: TMenuItem;
    ActionRegetProfileImage: TAction;
    popMenuItemRegetProfileImage: TMenuItem;
    MemoPostMessage: TMemo;
    ActionOpenWebThisTweet: TAction;
    popMenuItemOpenWebThisTweet: TMenuItem;
    ImageList: TImageList;
    TabControl: TTabControl;
    VirtualTreeView: TVirtualStringTree;
    ActionHelpAbout: TAction;
    menuItemHelp: TMenuItem;
    menuItemHelpAbout: TMenuItem;
    menuItemTab: TMenuItem;
    N2: TMenuItem;
    ImageRead: TImage;
    ActionPauseSpeech: TAction;
    CoolBar1: TCoolBar;
    ButtonedEditSearch: TButtonedEdit;
    ToolBar1: TToolBar;
    ToolButtonPauseSpeech: TToolButton;
    ActionAutoRefresh: TAction;
    menuItemAutoRefresh: TMenuItem;
    ToolButtonRefresh: TToolButton;
    ToolButtonAutoRefresh: TToolButton;
    ToolButton3: TToolButton;
    ToolButtonSpeak: TToolButton;
    PopupMenuTab: TPopupMenu;
    ActionCloseTab: TAction;
    popMenuItemCloseTab: TMenuItem;
    ActionSearchTweetVoice: TAction;
    N3: TMenuItem;
    menuItemSearchTweetVoice: TMenuItem;
    ActionCopyStatusToClipboard: TAction;
    ActionCopyStatusAllToClipboard: TAction;
    popMenuEdit: TMenuItem;
    popMenuItemCopyStatusToClipboard: TMenuItem;
    popMenuItemCopyStatusAllToClipboard: TMenuItem;
    ActionToolLogin: TAction;
    L1: TMenuItem;
    N4: TMenuItem;
    ActionAutoRequestOlderStatuses: TAction;
    popMenuItemAutoRequestOlderStatuses: TMenuItem;
    ActionUpdateSetRead: TAction;
    ActionUpdateSetUnread: TAction;
    ActionUpdateSetReadAll: TAction;
    ActionUpdateSetUnreadAll: TAction;
    popMenuItemUpdateSetRead: TMenuItem;
    popMenuItemUpdateSetUnread: TMenuItem;
    menuItemEdit: TMenuItem;
    menuItemUpdateSetRead: TMenuItem;
    menuItemUpdateSetUnead: TMenuItem;
    menuItemUpdateSetReadAll: TMenuItem;
    menuItemUpdateSetUnreadAll: TMenuItem;
    N5: TMenuItem;
    menuItemCopyStatusToClipboard: TMenuItem;
    menuItemCopyStatusAllToClipboard: TMenuItem;
    ActionCreateFavorites: TAction;
    popMenuItemFavorites: TMenuItem;
    popMenuItemCreateFavorites: TMenuItem;
    ActionDestroyFavorites: TAction;
    popMenuDestroyFavorites: TMenuItem;
    ActionCreateFriendship: TAction;
    popMenuItemCreateFriendShip: TMenuItem;
    ImageFavorited: TImage;
    ImageFollowingMe: TImage;
    ToolButton1: TToolButton;
    ToolButtonCreateFavorites: TToolButton;
    ActionFindSpokenStatus: TAction;
    ToolButton2: TToolButton;
    ImageFollowedByMe: TImage;
    ActionDestroyFriendship: TAction;
    popMenuItemDestroyFriendship: TMenuItem;
    menuItemLists: TMenuItem;
    menuItemCloseTab: TMenuItem;
    menuItemSavedSearch: TMenuItem;
    ActionCreateSavedSearch: TAction;
    N6: TMenuItem;
    popMenuItemCreateSavedSearch: TMenuItem;
    ImageFollowingEachOther: TImage;
    ToolButtonCreateFriendship: TToolButton;
    ActionSpeakAdd: TAction;
    ActionSpeakRemove: TAction;
    ToolButtonSpeakAdd: TToolButton;
    ToolButtonSpeakRemove: TToolButton;
    popMenuItemSpeakAdd: TMenuItem;
    popMenuItemSpeakRemove: TMenuItem;
    ActionImportUserNamePronounciations: TAction;
    OpenDialogImport: TOpenDialog;
    menuItemImportUserNamePronounciations: TMenuItem;
    ActionSetCaptionNormal: TAction;
    ActionSetBalloon: TAction;
    ActionSetCaptionWindow: TAction;
    ToolButton4: TToolButton;
    ToolButtonSetBalloon: TToolButton;
    ToolButtonSetCaptionNormal: TToolButton;
    ToolButtonSetCaptionWindow: TToolButton;
    PopupMenuTray: TPopupMenu;
    ActionApplicationExit: TAction;
    popTrayApplicationExit: TMenuItem;
    N7: TMenuItem;
    popTrayNotification: TMenuItem;
    popTraySetBalloon: TMenuItem;
    popTraySetCaptionNormal: TMenuItem;
    popTraySetCaptionWindow: TMenuItem;
    popTrayPauseSpeech: TMenuItem;
    menuItemNotification: TMenuItem;
    menuItemSetBalloon: TMenuItem;
    menuItemSetCaptionNormal: TMenuItem;
    menuItemSetCaptionWindow: TMenuItem;
    popTrayToolOptions: TMenuItem;
    ActionAddMyTweetTab: TAction;
    ActionAddFavoritesTab: TAction;
    ActionAddRepliesTab: TAction;
    ActionAddDirectMessagesTab: TAction;
    menuItemAddRepliesTab: TMenuItem;
    menuItemAddDirectMessagesTab: TMenuItem;
    menuItemAddFavoritesTab: TMenuItem;
    menuItemAddMyTweetTab: TMenuItem;
    ActionMuteSpeech: TAction;
    ToolButtonMuteSpeech: TToolButton;
    menuItemMuteSpeech: TMenuItem;
    ImageRetweet: TImage;
    ImageReply: TImage;
    ActionReply: TAction;
    ActionRetweet: TAction;
    ActionQuoteTweet: TAction;
    ToolButton5: TToolButton;
    ToolButtonReply: TToolButton;
    ToolButtonRetweet: TToolButton;
    ToolButton8: TToolButton;
    popMenuItemReply: TMenuItem;
    popMenuItemRetweet: TMenuItem;
    popMenuItemQuoteTweet: TMenuItem;
    ButtonClearText: TButton;
    ActionShortenURL: TAction;
    menuItemShortenURL: TMenuItem;
    ComboBoxUserNames: TComboBox;
    menuItemSpeakAdd: TMenuItem;
    menuItemSpeakRemove: TMenuItem;
    PanelFind: TPanel;
    ComboBoxFindWord: TComboBox;
    PanelPostStatus: TPanel;
    ComboBoxPostUserNames: TComboBox;
    Label1: TLabel;
    LabelReply: TLabel;
    ImageNoFavorited: TImage;
    ImageNoFollow: TImage;
    ImageUnread: TImage;
    ActionToggleRelativeDateString: TAction;
    menuItemToggleRelativeDateString: TMenuItem;
    ActionDestroySavedSearch: TAction;
    popMenuItemDestroySavedSearch: TMenuItem;
    LabelInReplyTo: TLabel;
    ButtonClosePanelPostStatus: TButton;
    menuItemPost: TMenuItem;
    menuItemReply: TMenuItem;
    menuItemRetweet: TMenuItem;
    menuItemQuoteTweet: TMenuItem;
    ActionPostDirectMessage: TAction;
    menuItemPostDirectMessage: TMenuItem;
    popMenuItemPostDirectMessage: TMenuItem;
    ButtonClosePanelFind: TButton;
    ActionFind: TAction;
    N8: TMenuItem;
    menuItemFind: TMenuItem;
    ButtonFindNext: TButton;
    ButtonFindPrevious: TButton;
    ActionFindNext: TAction;
    ActionFindPrevious: TAction;
    menuItemFindNext: TMenuItem;
    menuItemFindPrevious: TMenuItem;
    menuItemFindSpokenStatus: TMenuItem;
    ActionStatusViewSingleLine: TAction;
    menuItemSingleLineView: TMenuItem;
    ImageReadX: TImage;
    ImageFavoritedX: TImage;
    ImageFollowedByMeX: TImage;
    ImageFollowingEachOtherX: TImage;
    ImageFollowingMeX: TImage;
    ActionStatusViewNormal: TAction;
    ActionStatusViewJustFit: TAction;
    menuItemStatusViewNormal: TMenuItem;
    menuItemStatusViewJustFit: TMenuItem;
    meuItemStatusViewSingleLine: TMenuItem;
    ImageListTabs: TImageList;
    ButtonClosePanelPost: TButton;
    ActionShowPanelPost: TAction;
    menuItemShowPanelPost: TMenuItem;
    N9: TMenuItem;
    ActionAddRetweetedByMe: TAction;
    ActionAddRetweetsOfMe: TAction;
    N10: TMenuItem;
    menuItemAddRetweetedByMe: TMenuItem;
    menuItemAddRetweetsOfMe: TMenuItem;
    ActionAddSentDirectMessagesTab: TAction;
    menuItemAddSentDirectMessagesTab: TMenuItem;
    ActionCloseLeftTabs: TAction;
    ActionCloseRightTabs: TAction;
    ActionCloseInactiveTabs: TAction;
    menuItemCloseInactiveTabs: TMenuItem;
    popMenuItemCloseInactiveTabs: TMenuItem;
    menuItemCloseRightTabs: TMenuItem;
    menuItemCloseLeftTabs: TMenuItem;
    popMenuItemCloseRightTabs: TMenuItem;
    popMenuItemCloseLeftTabs: TMenuItem;
    procedure menuItemToolOptionsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure VirtualTreeViewDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode;
      Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
    procedure VirtualTreeViewMeasureItem(Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode;
      var NodeHeight: Integer);
    procedure VirtualTreeViewColumnResize(Sender: TVTHeader; Column: TColumnIndex);
    procedure TimerTimer(Sender: TObject);
    procedure VirtualTreeViewCompareNodes(Sender: TBaseVirtualTree; Node1, Node2: PVirtualNode; Column: TColumnIndex;
      var Result: Integer);
    //procedure VirtualTreeViewHeaderClick(Sender: TVTHeader; HitInfo: TVTHeaderHitInfo);
    procedure ActionSpeakExecute(Sender: TObject);
    procedure TimerBlinkTimer(Sender: TObject);
    procedure ActionRefreshExecute(Sender: TObject);
    procedure ActionShowFormUsersExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ActionOpenWebTwitterHomeExecute(Sender: TObject);
    procedure ActionOpenWebHPExecute(Sender: TObject);
    procedure ActionShowFormUserOptionsExecute(Sender: TObject);
    procedure ActionFormLogsExecute(Sender: TObject);
    procedure ActionRegetProfileImageExecute(Sender: TObject);
    procedure ButtonPostClick(Sender: TObject);
    procedure MemoPostMessageKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure VirtualTreeViewMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure VirtualTreeViewMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ActionOpenWebThisTweetExecute(Sender: TObject);
    procedure TrayIconMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ActionHelpAboutExecute(Sender: TObject);
    procedure TabControlChange(Sender: TObject);
    procedure ButtonedEditSearchRightButtonClick(Sender: TObject);
    procedure ActionPauseSpeechExecute(Sender: TObject);
    procedure ActionAutoRefreshExecute(Sender: TObject);
    procedure TabControlGetImageIndex(Sender: TObject; TabIndex: Integer; var ImageIndex: Integer);
    procedure TabControlMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ActionCloseTabExecute(Sender: TObject);
    procedure PopupMenuTabPopup(Sender: TObject);
    procedure ButtonedEditSearchKeyPress(Sender: TObject; var Key: Char);
    procedure ActionSearchTweetVoiceExecute(Sender: TObject);
    procedure ActionCopyStatusToClipboardExecute(Sender: TObject);
    procedure ActionCopyStatusAllToClipboardExecute(Sender: TObject);
    procedure VirtualTreeViewScroll(Sender: TBaseVirtualTree; DeltaX, DeltaY: Integer);
    procedure ActionToolLoginExecute(Sender: TObject);
    procedure ActionAutoRequestOlderStatusesExecute(Sender: TObject);
    procedure ActionUpdateSetReadExecute(Sender: TObject);
    procedure ActionUpdateSetUnreadExecute(Sender: TObject);
    procedure ActionUpdateSetReadAllExecute(Sender: TObject);
    procedure ActionUpdateSetUnreadAllExecute(Sender: TObject);
    procedure ActionCreateFavoritesExecute(Sender: TObject);
    procedure ActionDestroyFavoritesExecute(Sender: TObject);
    procedure VirtualTreeViewChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure ActionCreateFriendshipExecute(Sender: TObject);
    procedure ActionFindSpokenStatusExecute(Sender: TObject);
    procedure ActionDestroyFriendshipExecute(Sender: TObject);
    procedure ActionCreateSavedSearchExecute(Sender: TObject);
    procedure ActionSpeakRemoveExecute(Sender: TObject);
    procedure ActionSpeakAddExecute(Sender: TObject);
    procedure TabControlDrawTab(Control: TCustomTabControl; TabIndex: Integer; const Rect: TRect; Active: Boolean);
    procedure ActionImportUserNamePronounciationsExecute(Sender: TObject);
    procedure ActionSetCaptionNormalExecute(Sender: TObject);
    procedure ActionSetCaptionWindowExecute(Sender: TObject);
    procedure ActionSetBalloonExecute(Sender: TObject);
    procedure ActionApplicationExitExecute(Sender: TObject);
    procedure ActionAddMyTweetTabExecute(Sender: TObject);
    procedure ActionAddFavoritesTabExecute(Sender: TObject);
    procedure ActionAddRepliesTabExecute(Sender: TObject);
    procedure ActionAddDirectMessagesTabExecute(Sender: TObject);
    procedure ActionMuteSpeechExecute(Sender: TObject);
    procedure ActionReplyExecute(Sender: TObject);
    procedure ActionRetweetExecute(Sender: TObject);
    procedure ActionQuoteTweetExecute(Sender: TObject);
    procedure ButtonClearTextClick(Sender: TObject);
    procedure ActionShortenURLExecute(Sender: TObject);
    procedure MemoPostMessageKeyPress(Sender: TObject; var Key: Char);
    procedure ComboBoxUserNamesExit(Sender: TObject);
    procedure ComboBoxUserNamesKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ComboBoxUserNamesChange(Sender: TObject);
    procedure ActionToggleRelativeDateStringExecute(Sender: TObject);
    procedure ActionDestroySavedSearchExecute(Sender: TObject);
    procedure ButtonClosePanelPostStatusClick(Sender: TObject);
    procedure ActionPostDirectMessageExecute(Sender: TObject);
    procedure ComboBoxPostUserNamesChange(Sender: TObject);
    procedure ButtonClosePanelFindClick(Sender: TObject);
    procedure ActionFindExecute(Sender: TObject);
    procedure ActionFindPreviousExecute(Sender: TObject);
    procedure ActionFindNextExecute(Sender: TObject);
    procedure ComboBoxFindWordKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure VirtualTreeViewMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure VirtualTreeViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ActionStatusViewSingleLineExecute(Sender: TObject);
    procedure ComboBoxFindWordChange(Sender: TObject);
    procedure ActionStatusViewJustFitExecute(Sender: TObject);
    procedure ActionStatusViewNormalExecute(Sender: TObject);
    procedure ButtonClosePanelPostClick(Sender: TObject);
    procedure ActionShowPanelPostExecute(Sender: TObject);
    procedure ActionAddRetweetedByMeExecute(Sender: TObject);
    procedure ActionAddRetweetsOfMeExecute(Sender: TObject);
    procedure ActionAddSentDirectMessagesTabExecute(Sender: TObject);
    procedure ActionCloseInactiveTabsExecute(Sender: TObject);
    procedure ActionCloseLeftTabsExecute(Sender: TObject);
    procedure ActionCloseRightTabsExecute(Sender: TObject);
    procedure VirtualTreeViewHeaderClick(Sender: TVTHeader; Column: TColumnIndex; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
    FFormClosing: Boolean;
    FImageDownloader: TImageDownloader;
    FCommunicator: TCommunicator;
    FAuxCommunicator: TCommunicator;
    FSpeechThread: TSpeechThread;
    FBlinkAlpha: Integer;
    FAddedLineX: Integer;
    FWhiteBitmap: TBitmap;
    FRegExpScreenName: TPerlRegEx;
    FRequestedScreenNames: TDictionary<string, Integer>;
    FLogined: Boolean;
    FStatusesTabs: TXMLStatusesTabList;
    FAutoSpeechStartingTime: TDateTime;
    FReplyStatusID: Int64;
    FPostDirectMessage: Boolean;
    FHintWnd: THintWindow;
    FSavedSearches: TObjectList<TXMLSearch>;
    FSelectedNode: PVirtualNode;
    FCommIconProgress: Integer;

    procedure ClearTreeNodes;
    procedure RequestActiveStatuses;
    procedure RequestUsersLookup(AScreenNames: string);
    procedure RequestLists(AScreenName: string);
    procedure RequestSavedSearches;
    procedure RequestSpeech(AStatus: TXMLStatus; ATabID: Integer); overload;
    procedure RequestSpeech(ARequest: TSpeechRequest); overload;
    procedure RequestCreateFavorite(AID: Int64);
    procedure RequestDestroyFavorite(AID: Int64);
    procedure RequestFriendship(AScreenName: string; AUserID: Int64; AIsCreation: Boolean);
    procedure RequestFriends;
    procedure RepaintNode(AStatusID: Int64);
    procedure UpdateUI;
    procedure UpdateCaption;
    procedure UpdateTabs(ARecreate: Boolean = true);
    procedure UpdateStatusPanel0;
    procedure UpdateStatusPanel1;
    procedure UpdateVirtualTreeView;
    function AddVirtualTreeViewNode(AStatus: TXMLStatus): PVirtualNode;
    procedure RemoveVirtualTreeViewNode(AStatus: TXMLStatus);
    function GetSelectedNode: PVirtualNode;
    function GetSelectedNodes: TList<PVirtualNode>;
    procedure menuItemListsClick(Sender: TObject);
    procedure menuItemSearchClick(Sender: TObject);
    procedure HideHintWindow;
    procedure AddFindWordToComboBox;
  public
    { Public 錾 }
    procedure SetBitmaps(AUrlBitmaps: TList<TUrlBitmap>);
    procedure SetCommunicatorResult(ARequest: TCommRequest);
    procedure SpeakCompleted(ARequest: TSpeechRequest);
    procedure ShowBalloonHit(AStatus: TXMLStatus);
    procedure AddUserTimelineTab(AUserName: string);
    procedure AddSearchTab(ASearchWord: string);
    procedure WMMousewheel(var Msg: TMessage); message WM_MOUSEWHEEL;
    property ImageDownloader: TImageDownloader read FImageDownloader;
  end;

  TTreeData = record
    Status: TXMLStatus;
    SourceRectView: TRectView;
    TextRectView: TRectView;
    UserRectView: TRectView;
    pNodeData: Pointer;
  end;

  PTreeData = ^TTreeData;

var
  FormMainTweetVoice: TFormMainTweetVoice;

implementation

uses tvFormOptions, tvUserConfig, tvXMLUserManager, tvFormUsers, tvFormUserOptions, tvDBManager, tvFormLogs,
  tvFormLogin, OAuth, tvFormAbout, tvOAuth, tvFormCaption, tvXMLStatusManager;
{$R *.dfm}

procedure TFormMainTweetVoice.ActionToggleRelativeDateStringExecute(Sender: TObject);
begin
  UserConfig.RelativeDateString := Not UserConfig.RelativeDateString;
  VirtualTreeView.Refresh;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ActionToolLoginExecute(Sender: TObject);
begin
  FLogined := false;
  FormLogin.HideFormLoginStartup := Not UserConfig.ShowFormLoginStartUp;
  if (FormLogin.ShowModal = mrOK) then
  begin
    // UserConfig.ShowFormLoginStartUp := Not FormLogin.HideFormLoginStartup;
    UserConfig.ApplyFontSizeToForms;
    FLogined := true;
    Caption := 'TweetVoice - @' + UserConfig.DefaultUserName;
    FStatusesTabs.ClearAllStatuses;
    RequestFriends;
    FStatusesTabs.RequestStatuses(Self, FCommunicator);
    RequestLists(UserConfig.DefaultUserName);
    RequestSavedSearches;
    UpdateStatusPanel0;
    UpdateUI;
    UpdateVirtualTreeView;
  end;
  FLogined := true;
end;

procedure TFormMainTweetVoice.ActionUpdateSetReadAllExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  Screen.Cursor := crHourGlass;
  Node := VirtualTreeView.RootNode.FirstChild;
  while (Node <> nil) do
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    dataPtr.Status.GetRetweetedStatus.IsRead := true;
    VirtualTreeView.RepaintNode(Node);
    DBManager.UpdateStatusIsRead(dataPtr.Status.GetRetweetedStatus);
    Node := Node.NextSibling;
  end;
  DBManager.Commit;
  Screen.Cursor := crDefault;
  UpdateTabs(false);
end;

procedure TFormMainTweetVoice.ActionUpdateSetReadExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Nodes: TList<PVirtualNode>;
begin
  Nodes := GetSelectedNodes;
  try
    if (Nodes.Count <> 0) then
    begin
      for Node in Nodes do
      begin
        dataPtr := VirtualTreeView.GetNodeData(Node);
        dataPtr.Status.GetRetweetedStatus.IsRead := true;
        VirtualTreeView.RepaintNode(Node);
        DBManager.UpdateStatusIsRead(dataPtr.Status.GetRetweetedStatus);
      end;
    end;
    DBManager.Commit;
  finally
    Nodes.Free;
  end;
  UpdateTabs(false);
end;

procedure TFormMainTweetVoice.ActionUpdateSetUnreadAllExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  Screen.Cursor := crHourGlass;
  Node := VirtualTreeView.RootNode.FirstChild;
  while (Node <> nil) do
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    dataPtr.Status.GetRetweetedStatus.IsRead := false;
    VirtualTreeView.RepaintNode(Node);
    DBManager.UpdateStatusIsRead(dataPtr.Status.GetRetweetedStatus);
    Node := Node.NextSibling;
  end;
  DBManager.Commit;
  Screen.Cursor := crDefault;
  UpdateTabs(false);
end;

procedure TFormMainTweetVoice.ActionUpdateSetUnreadExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Nodes: TList<PVirtualNode>;
begin
  Nodes := GetSelectedNodes;
  try
    if (Nodes.Count <> 0) then
    begin
      for Node in Nodes do
      begin
        dataPtr := VirtualTreeView.GetNodeData(Node);
        dataPtr.Status.GetRetweetedStatus.IsRead := false;
        VirtualTreeView.RepaintNode(Node);
        DBManager.UpdateStatusIsRead(dataPtr.Status.GetRetweetedStatus);
      end;
    end;
    DBManager.Commit;
  finally
    Nodes.Free;
  end;
  UpdateTabs(false);
end;

procedure TFormMainTweetVoice.AddFindWordToComboBox;
var
  words: TStringList;
  idx: Integer;
begin
  words := TStringList.Create;
  try
    words.Assign(ComboBoxFindWord.Items);
    idx := words.IndexOf(ComboBoxFindWord.Text);
    if (idx >= 0) then
    begin
      words.Delete(idx);
    end;
    words.Insert(0, ComboBoxFindWord.Text);
    ComboBoxFindWord.Items.Assign(words);
  finally
    words.Free;
  end;
end;

procedure TFormMainTweetVoice.AddSearchTab(ASearchWord: string);
var
  tab: TXMLStatusesTab;
begin
  tab := TXMLStatusesTab.Create;
  tab.TabType := ttSearch;
  tab.SearchWord := ASearchWord;
  FStatusesTabs.Add(tab);
  UpdateTabs;
  tab.RequestStatuses(Self, FCommunicator);
  TabControl.TabIndex := FStatusesTabs.IndexOfTabID(tab.TabID);
  UpdateVirtualTreeView;
  UpdateStatusPanel0;
  UpdateStatusPanel1;
end;

procedure TFormMainTweetVoice.AddUserTimelineTab(AUserName: string);
var
  tab: TXMLStatusesTab;
begin
  tab := TXMLStatusesTab.Create;
  tab.TabType := ttUserTimeline;
  tab.UserName := AUserName;
  FStatusesTabs.Add(tab);
  UpdateTabs;
  tab.RequestStatuses(Self, FCommunicator);
  TabControl.TabIndex := FStatusesTabs.IndexOfTabID(tab.TabID);
  UpdateVirtualTreeView;
  UpdateStatusPanel0;
  UpdateStatusPanel1;
end;

function TFormMainTweetVoice.AddVirtualTreeViewNode(AStatus: TXMLStatus): PVirtualNode;
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Status: TXMLStatus;
  retweetStatus: TXMLStatus;
begin
  retweetStatus := nil;
  Status := AStatus;
  if Assigned(Status.RetweetedStatus) then
  begin
    Status := Status.RetweetedStatus;
    retweetStatus := AStatus;
  end;
  Node := VirtualTreeView.AddChild(nil);
  dataPtr := VirtualTreeView.GetNodeData(Node);
  dataPtr.Status := AStatus;
  dataPtr.SourceRectView := Status.CreateSourceRectView;
  dataPtr.UserRectView := Status.User.CreateUserRectView(true, retweetStatus);
  dataPtr.TextRectView := TRectView.Create;
  dataPtr.TextRectView.Text := Status.Text;
  Result := Node;
end;

procedure TFormMainTweetVoice.ButtonClearTextClick(Sender: TObject);
begin
  // UserDigestInfos.Free;
  // UserDigestInfos := DBManager.SelectAllUsers;
  FReplyStatusID := 0;
  FPostDirectMessage := false;
  MemoPostMessage.Text := '';
  UpdateUI;

end;

procedure TFormMainTweetVoice.ButtonClosePanelFindClick(Sender: TObject);
begin
  PanelFind.Hide;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ButtonClosePanelPostClick(Sender: TObject);
begin
  ActionShowPanelPost.Checked := false;
  PanelPost.Hide;
end;

procedure TFormMainTweetVoice.ButtonClosePanelPostStatusClick(Sender: TObject);
begin
  FReplyStatusID := 0;
  FPostDirectMessage := false;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ButtonedEditSearchKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = Char(13)) then
  begin
    ButtonedEditSearchRightButtonClick(Sender);
    Key := Char(0);
  end;
end;

procedure TFormMainTweetVoice.ButtonedEditSearchRightButtonClick(Sender: TObject);
begin
  if (ButtonedEditSearch.Text = '') then
  begin
    Exit;
  end;

  AddSearchTab(ButtonedEditSearch.Text);
end;

procedure TFormMainTweetVoice.ButtonPostClick(Sender: TObject);
var
  request: TCommUpdateStatus;
  dmRequest: TCommDirectMessageNewStatus;
  url: string;
  s: string;
  tab: TXMLStatusesTab;
  res: Integer;
begin
  s := MemoPostMessage.Text;

  tab := FStatusesTabs[TabControl.TabIndex];
  if (not FPostDirectMessage) and (tab.TabType = ttSearch) and StrUtils.StartsStr('#', tab.SearchWord) then
  begin
    if Not(StrUtils.ContainsText(s, ' ' + tab.SearchWord)) then
    begin
      res := MessageDlg('nbV^O' + tab.SearchWord + 'ǉ܂H', mtWarning, mbYesNoCancel, 0);
      if (res = mrYes) then
      begin
        s := s + ' ' + tab.SearchWord;
      end
      else if (res = mrCancel) then
      begin
        Exit;
      end;
    end;
  end;

  if (Length(s) > 140) then
  begin
    if Not(URLShortener.CanShortenUrlInText(s)) then
    begin
      ShowMessage('bZ[W܂B');
      Exit;
    end;
    if (MessageDlg('bZ[W܂BURLZk܂H', mtConfirmation, mbYesNo, 0) = mrYes) then
    begin
      s := URLShortener.ShortenUrlInText(s);
      if (Length(s) > 140) then
      begin
        MemoPostMessage.Text := s;
        Exit;
      end;
    end
    else
    begin
      Exit;
    end;
  end;

  if (FPostDirectMessage) then
  begin
    dmRequest := TCommDirectMessageNewStatus.Create(Self);
    dmRequest.url := '1/direct_messages/new.xml';
    dmRequest.Parameters.Add('text=' + TOAuthUtil.urlEncodeRawRFC3986(UTF8Encode(s)));
    dmRequest.Parameters.Add('user=' + ComboBoxPostUserNames.Text);
    FCommunicator.Enqueue(dmRequest);
  end
  else
  begin
    request := TCommUpdateStatus.Create(Self);

    url := '1/statuses/update.xml';
    request.Parameters.Add('status=' + TOAuthUtil.urlEncodeRawRFC3986(UTF8Encode(s)));
    if (FReplyStatusID <> 0) then
    begin
      request.Parameters.Add('in_reply_to_status_id=' + IntToStr(FReplyStatusID));
    end;
    request.url := url;
    request.TabID := FStatusesTabs[0].TabID;
    FCommunicator.Enqueue(request);
  end;

  FReplyStatusID := 0;
  FPostDirectMessage := false;
  MemoPostMessage.Text := '';
end;

procedure TFormMainTweetVoice.ActionShowPanelPostExecute(Sender: TObject);
begin
  ActionShowPanelPost.Checked := Not ActionShowPanelPost.Checked;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ActionAddDirectMessagesTabExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
begin
  // DMǉ
  tab := TXMLStatusesTab.Create;
  tab.TabType := ttDirectMessages;
  FStatusesTabs.Add(tab);
  UpdateTabs;
  tab.RequestStatuses(Self, FCommunicator);
  TabControl.TabIndex := FStatusesTabs.IndexOfTabID(tab.TabID);
  UpdateVirtualTreeView;
  UpdateStatusPanel0;
  UpdateStatusPanel1;
end;

procedure TFormMainTweetVoice.ActionAddFavoritesTabExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
begin
  // Cɓǉ
  tab := TXMLStatusesTab.Create;
  tab.TabType := ttFavorites;
  FStatusesTabs.Add(tab);
  UpdateTabs;
  tab.RequestStatuses(Self, FCommunicator);
  TabControl.TabIndex := FStatusesTabs.IndexOfTabID(tab.TabID);
  UpdateVirtualTreeView;
  UpdateStatusPanel0;
  UpdateStatusPanel1;
end;

procedure TFormMainTweetVoice.ActionAddMyTweetTabExecute(Sender: TObject);
begin
  AddUserTimelineTab(UserConfig.DefaultUserName);
end;

procedure TFormMainTweetVoice.ActionAddRepliesTabExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
begin
  // ԐMǉ
  tab := TXMLStatusesTab.Create;
  tab.TabType := ttReplies;
  FStatusesTabs.Add(tab);
  UpdateTabs;
  tab.RequestStatuses(Self, FCommunicator);
  TabControl.TabIndex := FStatusesTabs.IndexOfTabID(tab.TabID);
  UpdateVirtualTreeView;
  UpdateStatusPanel0;
  UpdateStatusPanel1;
end;

procedure TFormMainTweetVoice.ActionAddRetweetedByMeExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
begin
  // RTcC[gǉ
  tab := TXMLStatusesTab.Create;
  tab.TabType := ttRetweetedByMe;
  FStatusesTabs.Add(tab);
  UpdateTabs;
  tab.RequestStatuses(Self, FCommunicator);
  TabControl.TabIndex := FStatusesTabs.IndexOfTabID(tab.TabID);
  UpdateVirtualTreeView;
  UpdateStatusPanel0;
  UpdateStatusPanel1;
end;

procedure TFormMainTweetVoice.ActionAddRetweetsOfMeExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
begin
  // RTꂽ̃cC[gǉ
  tab := TXMLStatusesTab.Create;
  tab.TabType := ttRetweetsOfMe;
  FStatusesTabs.Add(tab);
  UpdateTabs;
  tab.RequestStatuses(Self, FCommunicator);
  TabControl.TabIndex := FStatusesTabs.IndexOfTabID(tab.TabID);
  UpdateVirtualTreeView;
  UpdateStatusPanel0;
  UpdateStatusPanel1;
end;

procedure TFormMainTweetVoice.ActionAddSentDirectMessagesTabExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
begin
  // DMǉ
  tab := TXMLStatusesTab.Create;
  tab.TabType := ttSentDirectMessages;
  FStatusesTabs.Add(tab);
  UpdateTabs;
  tab.RequestStatuses(Self, FCommunicator);
  TabControl.TabIndex := FStatusesTabs.IndexOfTabID(tab.TabID);
  UpdateVirtualTreeView;
  UpdateStatusPanel0;
  UpdateStatusPanel1;
end;

procedure TFormMainTweetVoice.ActionApplicationExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TFormMainTweetVoice.ActionAutoRefreshExecute(Sender: TObject);
begin
  UserConfig.AutoRefresh := not UserConfig.AutoRefresh;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ActionAutoRequestOlderStatusesExecute(Sender: TObject);
begin
  UserConfig.AutoRequestOlderStatuses := Not UserConfig.AutoRequestOlderStatuses;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ActionCloseInactiveTabsExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
  activeTab: TXMLStatusesTab;
  activeIndex: Integer;
  i: Integer;
begin
  activeIndex := TabControl.TabIndex;
  activeTab := FStatusesTabs[activeIndex];
  for i := FStatusesTabs.Count - 1 downto 0 do
  begin
    tab := FStatusesTabs[i];
    if tab.CanClose and (i <> activeIndex) then
    begin
      FStatusesTabs.Remove(tab);
    end;
  end;
  UpdateTabs;
  activeIndex := FStatusesTabs.IndexOfTabID(activeTab.TabID);
  if (activeIndex >= 0) then
  begin
    TabControl.TabIndex := activeIndex;
  end;
  UpdateVirtualTreeView;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ActionCloseLeftTabsExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
  activeTab: TXMLStatusesTab;
  activeIndex: Integer;
  i: Integer;
begin
  activeIndex := TabControl.TabIndex;
  activeTab := FStatusesTabs[activeIndex];
  for i := FStatusesTabs.Count - 1 downto 0 do
  begin
    tab := FStatusesTabs[i];
    if tab.CanClose and (i < activeIndex) then
    begin
      FStatusesTabs.Remove(tab);
    end;
  end;
  UpdateTabs;
  activeIndex := FStatusesTabs.IndexOfTabID(activeTab.TabID);
  if (activeIndex >= 0) then
  begin
    TabControl.TabIndex := activeIndex;
  end;
  UpdateVirtualTreeView;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ActionCloseRightTabsExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
  activeTab: TXMLStatusesTab;
  activeIndex: Integer;
  i: Integer;
begin
  activeIndex := TabControl.TabIndex;
  activeTab := FStatusesTabs[activeIndex];
  for i := FStatusesTabs.Count - 1 downto 0 do
  begin
    tab := FStatusesTabs[i];
    if tab.CanClose and (i > activeIndex) then
    begin
      FStatusesTabs.Remove(tab);
    end;
  end;
  UpdateTabs;
  activeIndex := FStatusesTabs.IndexOfTabID(activeTab.TabID);
  if (activeIndex >= 0) then
  begin
    TabControl.TabIndex := activeIndex;
  end;
  UpdateVirtualTreeView;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ActionCloseTabExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
  closeIndex: Integer;
begin
  closeIndex := TabControl.TabIndex;
  tab := FStatusesTabs[closeIndex];

  if tab.CanClose then
  begin
    FStatusesTabs.Remove(tab);
    UpdateTabs;
    TabControl.TabIndex := closeIndex - 1;
    UpdateVirtualTreeView;
    UpdateUI;
  end;
end;

procedure TFormMainTweetVoice.ActionCopyStatusAllToClipboardExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Nodes: TList<PVirtualNode>;
  s: string;
  crlf: string;
begin
  Nodes := GetSelectedNodes;
  try
    if (Nodes.Count <> 0) then
    begin
      if (Nodes.Count > 1) then
      begin
        crlf := #$d + #$a;
      end;

      for Node in Nodes do
      begin
        dataPtr := VirtualTreeView.GetNodeData(Node);
        s := s + dataPtr.Status.GetAllText + crlf;
      end;
      Clipboard.AsText := s;
    end;
  finally
    Nodes.Free;
  end;
end;

procedure TFormMainTweetVoice.ActionCopyStatusToClipboardExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Nodes: TList<PVirtualNode>;
  s: string;
  crlf: string;
  edit: TEdit;
  buttonedEdit: TButtonedEdit;
  memo: TMemo;
  comboBox: TComboBox;
begin
  if (ActiveControl is TButtonedEdit) then
  begin
    buttonedEdit := TButtonedEdit(ActiveControl);
    buttonedEdit.Perform(WM_COPY, 0, 0);
  end
  else if (ActiveControl is TMemo) then
  begin
    memo := TMemo(ActiveControl);
    memo.Perform(WM_COPY, 0, 0);
  end
  else if (ActiveControl is TEdit) then
  begin
    edit := TEdit(ActiveControl);
    edit.Perform(WM_COPY, 0, 0);
  end
  else if (ActiveControl is TComboBox) then
  begin
    comboBox := TComboBox(ActiveControl);
    comboBox.Perform(WM_COPY, 0, 0);
  end
  else
  begin
    if Assigned(FSelectedNode) then
    begin
      dataPtr := VirtualTreeView.GetNodeData(FSelectedNode);
      s := dataPtr.TextRectView.SelectedText;
      if (s <> '') then
      begin
        Clipboard.AsText := s;
        Exit;
      end;
    end;

    Nodes := GetSelectedNodes;
    try
      if (Nodes.Count <> 0) then
      begin
        if (Nodes.Count > 1) then
        begin
          crlf := #$d + #$a;
        end;

        for Node in Nodes do
        begin
          dataPtr := VirtualTreeView.GetNodeData(Node);
          s := s + dataPtr.Status.GetRetweetedStatus.Text + crlf;
        end;
        Clipboard.AsText := s;
      end;
    finally
      Nodes.Free;
    end;
  end;
end;

procedure TFormMainTweetVoice.ActionCreateFavoritesExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Nodes: TList<PVirtualNode>;
begin
  Nodes := GetSelectedNodes;
  try
    if (Nodes.Count <> 0) then
    begin
      for Node in Nodes do
      begin
        dataPtr := VirtualTreeView.GetNodeData(Node);
        RequestCreateFavorite(dataPtr.Status.GetRetweetedStatus.ID);
      end;
    end;
  finally
    Nodes.Free;
  end;
end;

procedure TFormMainTweetVoice.ActionCreateFriendshipExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Nodes: TList<PVirtualNode>;
begin
  Nodes := GetSelectedNodes;
  try
    if (Nodes.Count <> 0) then
    begin
      for Node in Nodes do
      begin
        dataPtr := VirtualTreeView.GetNodeData(Node);
        if (dataPtr.Status.GetRetweetedStatus.ID <> 0) then
        begin
          RequestFriendship(dataPtr.Status.GetRetweetedStatus.User.ScreenName,
            dataPtr.Status.GetRetweetedStatus.User.ID, true);
        end;
      end;
    end;
  finally
    Nodes.Free;
  end;
end;

procedure TFormMainTweetVoice.ActionCreateSavedSearchExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
  request: TCommRequestSavedSearchesOperation;
begin
  tab := FStatusesTabs[TabControl.TabIndex];
  if (tab.TabType = ttSearch) then
  begin
    request := TCommRequestSavedSearchesOperation.Create(Self);
    request.IsCreation := true;
    request.Query := tab.SearchWord;
    FAuxCommunicator.Enqueue(request);
  end;
end;

procedure TFormMainTweetVoice.ActionDestroyFavoritesExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Nodes: TList<PVirtualNode>;
begin
  Nodes := GetSelectedNodes;
  try
    if (Nodes.Count <> 0) then
    begin
      for Node in Nodes do
      begin
        dataPtr := VirtualTreeView.GetNodeData(Node);
        RequestDestroyFavorite(dataPtr.Status.GetRetweetedStatus.ID);
      end;
    end;
  finally
    Nodes.Free;
  end;
end;

procedure TFormMainTweetVoice.ActionDestroyFriendshipExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Nodes: TList<PVirtualNode>;
begin
  if (MessageDlg('tH[܂H', mtConfirmation, mbYesNo, 0) <> mrYes) then
  begin
    Exit;
  end;
  Nodes := GetSelectedNodes;
  try
    if (Nodes.Count <> 0) then
    begin
      for Node in Nodes do
      begin
        dataPtr := VirtualTreeView.GetNodeData(Node);
        if (dataPtr.Status.User.ID <> 0) then
        begin
          RequestFriendship(dataPtr.Status.GetRetweetedStatus.User.ScreenName,
            dataPtr.Status.GetRetweetedStatus.User.ID, false);
        end;
      end;
    end;
  finally
    Nodes.Free;
  end;
end;

procedure TFormMainTweetVoice.ActionDestroySavedSearchExecute(Sender: TObject);
var
  search: TXMLSearch;
  ID: Int64;
  request: TCommRequestSavedSearchesOperation;
  tab: TXMLStatusesTab;
begin
  ID := -1;
  tab := FStatusesTabs[TabControl.TabIndex];
  if (tab.TabType = ttSearch) then
  begin
    for search in FSavedSearches do
    begin
      if (CompareText(search.Query, tab.SearchWord) = 0) then
      begin
        ID := search.ID;
        break;
      end;
    end;
    if (ID >= 0) then
    begin
      request := TCommRequestSavedSearchesOperation.Create(Self);
      request.IsCreation := false;
      request.ID := ID;
      FAuxCommunicator.Enqueue(request);
    end;
  end;

end;

procedure TFormMainTweetVoice.ActionFormLogsExecute(Sender: TObject);
begin
  FormLogs.Show;
end;

procedure TFormMainTweetVoice.ActionFindExecute(Sender: TObject);
begin
  PanelFind.Show;
  ComboBoxFindWord.SetFocus;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ActionFindNextExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  AddFindWordToComboBox;
  Node := GetSelectedNode;
  if Not Assigned(Node) then
  begin
    // ŏ
    Node := VirtualTreeView.RootNode.FirstChild;
  end
  else
  begin
    Node := Node.NextSibling;
  end;
  while (Node <> nil) do
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);

    if dataPtr.Status.GetRetweetedStatus.ContainsText(ComboBoxFindWord.Text) then
    begin
      VirtualTreeView.ClearSelection;
      VirtualTreeView.Selected[Node] := true;
      VirtualTreeView.ScrollIntoView(Node, true);
      break;
    end;
    Node := Node.NextSibling;
  end;
end;

procedure TFormMainTweetVoice.ActionFindPreviousExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  AddFindWordToComboBox;
  Node := GetSelectedNode;
  if Not Assigned(Node) then
  begin
    // ŏ
    Node := VirtualTreeView.RootNode.FirstChild;
  end
  else
  begin
    Node := Node.PrevSibling;
  end;
  while (Node <> nil) do
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);

    if dataPtr.Status.GetRetweetedStatus.ContainsText(ComboBoxFindWord.Text) then
    begin
      VirtualTreeView.ClearSelection;
      VirtualTreeView.Selected[Node] := true;
      VirtualTreeView.ScrollIntoView(Node, true);
      break;
    end;
    Node := Node.PrevSibling;
  end;
end;

procedure TFormMainTweetVoice.ActionFindSpokenStatusExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  LastSpeechStatusNode: PVirtualNode;
begin
  LastSpeechStatusNode := nil;
  Node := VirtualTreeView.RootNode.FirstChild;
  while (Node <> nil) do
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    if (FSpeechThread.IsSpeaking(dataPtr.Status)) then
    begin
      VirtualTreeView.ScrollIntoView(Node, true);
      Exit;
    end;
    if (FStatusesTabs[TabControl.TabIndex].LastSpeechStatusID = dataPtr.Status.ID) then
    begin
      LastSpeechStatusNode := Node;
    end;
    Node := Node.NextSibling;
  end;

  if Assigned(LastSpeechStatusNode) then
  begin
    VirtualTreeView.ScrollIntoView(LastSpeechStatusNode, true);
  end;
end;

procedure TFormMainTweetVoice.ActionHelpAboutExecute(Sender: TObject);
var
  request: TCommRateLimiteStatus;
begin
  FormAbout.MemoRateLimiteStatus.Lines.Clear;
  request := TCommRateLimiteStatus.Create(Self);
  request.url := '1/account/rate_limit_status.xml';
  FCommunicator.Enqueue(request);
  FormAbout.ShowModal;
end;

procedure TFormMainTweetVoice.ActionImportUserNamePronounciationsExecute(Sender: TObject);
begin
  if (OpenDialogImport.Execute) then
  begin
    DBManager.ImportPronounciations(OpenDialogImport.FIleName);
  end;
end;

procedure TFormMainTweetVoice.ActionMuteSpeechExecute(Sender: TObject);
begin
  UserConfig.MuteSpeech := Not UserConfig.MuteSpeech;
  UpdateUI;
end;

procedure TFormMainTweetVoice.ActionOpenWebHPExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  Node := GetSelectedNode;
  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    dataPtr.Status.GetRetweetedStatus.User.OpenWebHP;
  end;
end;

procedure TFormMainTweetVoice.ActionOpenWebThisTweetExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  Node := GetSelectedNode;
  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    dataPtr.Status.GetRetweetedStatus.OpenWebTweet;
  end;
end;

procedure TFormMainTweetVoice.ActionOpenWebTwitterHomeExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  Node := GetSelectedNode;
  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    dataPtr.Status.GetRetweetedStatus.User.OpenWebTwitterHome;
  end;
end;

procedure TFormMainTweetVoice.ActionPauseSpeechExecute(Sender: TObject);
begin
  UserConfig.PauseSpeech := Not UserConfig.PauseSpeech;
  UpdateUI;
  UpdateTabs(false);
end;

procedure TFormMainTweetVoice.ActionPostDirectMessageExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  User: TXMLUser;
begin
  FReplyStatusID := 0;
  FPostDirectMessage := true;
  ActionShowPanelPost.Checked := true;
  PanelPost.Show;
  MemoPostMessage.Text := '';
  ActiveControl := MemoPostMessage;
  Node := GetSelectedNode;
  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    User := dataPtr.Status.GetRetweetedStatus.User;
    if (User.FollowingIndex = 3) then
    begin
      ComboBoxPostUserNames.Text := LowerCase(User.LowScreenName);
    end;
  end;

  UpdateUI;
end;

procedure TFormMainTweetVoice.ActionQuoteTweetExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  Node := GetSelectedNode;
  if Assigned(Node) then
  begin
    ActionShowPanelPost.Checked := true;
    PanelPost.Show;
    dataPtr := VirtualTreeView.GetNodeData(Node);
    FReplyStatusID := 0;
    FPostDirectMessage := false;
    MemoPostMessage.Text := ' QT @' + dataPtr.Status.User.ScreenName + ' ' + dataPtr.Status.Text;
    MemoPostMessage.SelStart := 0;
    ActiveControl := MemoPostMessage;
    UpdateUI;
  end;
end;

procedure TFormMainTweetVoice.ActionRefreshExecute(Sender: TObject);
begin
  if (FLogined) then
  begin
    RequestActiveStatuses;
  end;
end;

procedure TFormMainTweetVoice.ActionRegetProfileImageExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  User: TXMLUser;
  urlBitmap: TUrlBitmap;
begin
  Node := GetSelectedNode;
  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    User := dataPtr.Status.User;
    if Assigned(dataPtr.Status.RetweetedStatus) then
    begin
      User := dataPtr.Status.RetweetedStatus.User;
    end;
    User.ProfileImage.Free;
    User.ProfileImage := nil;
    urlBitmap := TUrlBitmap.Create;
    urlBitmap.User := User;
    FImageDownloader.EnqueueUrl(urlBitmap);
  end;
end;

procedure TFormMainTweetVoice.ActionReplyExecute(Sender: TObject);
var
  selectedNodes: TList<PVirtualNode>;
  Node: PVirtualNode;
  dataPtr: PTreeData;
  s: string;
begin
  selectedNodes := GetSelectedNodes;
  try
    if (selectedNodes.Count > 0) then
    begin
      FPostDirectMessage := false;
      ActionShowPanelPost.Checked := true;
      PanelPost.Show;
      if (selectedNodes.Count = 1) then
      begin
        dataPtr := VirtualTreeView.GetNodeData(selectedNodes[0]);
        FReplyStatusID := dataPtr.Status.GetRetweetedStatus.ID;
        MemoPostMessage.Text := '@' + dataPtr.Status.User.ScreenName + ' ';
      end
      else
      begin
        FReplyStatusID := 0;
        s := '.';
        for Node in selectedNodes do
        begin
          dataPtr := VirtualTreeView.GetNodeData(Node);
          s := s + '@' + dataPtr.Status.User.ScreenName + ' ';
        end;
        MemoPostMessage.Text := s;
      end;
      ActiveControl := MemoPostMessage;
      MemoPostMessage.SelStart := Length(MemoPostMessage.Text);
      UpdateUI;
    end;
  finally
    selectedNodes.Free;
  end;

end;

procedure TFormMainTweetVoice.ActionRetweetExecute(Sender: TObject);
var
  request: TCommRetweetStatus;
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  Node := GetSelectedNode;
  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    if (MessageDlg('̂Ԃ₫cC[g܂H', mtConfirmation, mbYesNo, 0) = mrYes) then
    begin
      request := TCommRetweetStatus.Create(Self);
      request.url := '1/statuses/retweet/' + IntToStr(dataPtr.Status.GetRetweetedStatus.ID) + '.xml';
      request.TabID := FStatusesTabs[0].TabID;

      FCommunicator.Enqueue(request);
    end;
  end;
end;

procedure TFormMainTweetVoice.ActionSearchTweetVoiceExecute(Sender: TObject);
begin
  AddSearchTab('#TweetVoice');
end;

procedure TFormMainTweetVoice.ActionSetBalloonExecute(Sender: TObject);
begin
  if (UserConfig.CaptionType = ctBalloon) then
  begin
    UserConfig.CaptionType := ctNone;
  end
  else
  begin
    UserConfig.CaptionType := ctBalloon;
  end;
  UpdateUI;
  UpdateCaption;
end;

procedure TFormMainTweetVoice.ActionSetCaptionNormalExecute(Sender: TObject);
begin
  if (UserConfig.CaptionType = ctCaptionNormal) then
  begin
    UserConfig.CaptionType := ctNone;
  end
  else
  begin
    UserConfig.CaptionType := ctCaptionNormal;
  end;
  UpdateUI;
  UpdateCaption;
end;

procedure TFormMainTweetVoice.ActionSetCaptionWindowExecute(Sender: TObject);
begin
  if (UserConfig.CaptionType = ctCaptionWindow) then
  begin
    UserConfig.CaptionType := ctNone;
  end
  else
  begin
    UserConfig.CaptionType := ctCaptionWindow;
  end;
  UpdateUI;
  UpdateCaption;

end;

procedure TFormMainTweetVoice.ActionShortenURLExecute(Sender: TObject);
var
  s: string;
begin
  if Not(UserConfig.URLShortenerConfig.Enabled) then
  begin
    ShowMessage('URLZk̐ݒsĂ');
    Exit;
  end;

  s := MemoPostMessage.Text;

  if Not(URLShortener.CanShortenUrlInText(s)) then
  begin
    ShowMessage('ZkłURL܂');
    Exit;
  end;

  Screen.Cursor := crHourGlass;
  try
    MemoPostMessage.Text := URLShortener.ShortenUrlInText(s);

  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TFormMainTweetVoice.ActionShowFormUserOptionsExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  User: TXMLUser;
begin
  Node := GetSelectedNode;
  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    User := dataPtr.Status.GetRetweetedStatus.User;
    FormUserOptions.SetFrom(User);
    if (FormUserOptions.ShowModal = mrOK) then
    begin
      FormUserOptions.SetTo(User);
      Screen.Cursor := crHourGlass;
      try
        DBManager.InsertOrUpdateUser(User);
      finally
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TFormMainTweetVoice.ActionShowFormUsersExecute(Sender: TObject);
begin
  FormUsers.Show;
end;

procedure TFormMainTweetVoice.ActionStatusViewJustFitExecute(Sender: TObject);
begin
  UserConfig.StatusViewType := svJustFit;
  UpdateUI;
  VirtualTreeView.ReinitChildren(nil, false);
  VirtualTreeView.Repaint;
end;

procedure TFormMainTweetVoice.ActionStatusViewNormalExecute(Sender: TObject);
begin
  UserConfig.StatusViewType := svNormal;
  UpdateUI;
  VirtualTreeView.ReinitChildren(nil, false);
  VirtualTreeView.Repaint;
end;

procedure TFormMainTweetVoice.ActionStatusViewSingleLineExecute(Sender: TObject);
begin
  UserConfig.StatusViewType := svSingleLine;
  UpdateUI;
  VirtualTreeView.ReinitChildren(nil, false);
  VirtualTreeView.Repaint;
end;

procedure TFormMainTweetVoice.ActionSpeakAddExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  tab: TXMLStatusesTab;
  Status: TXMLStatus;
begin
  Node := GetSelectedNode;
  tab := FStatusesTabs[TabControl.TabIndex];

  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    Status := dataPtr.Status;
    RequestSpeech(Status, tab.TabID);
    FStatusesTabs.AddSpeechTab(tab.TabID, Status.ID);
  end
  else
  begin
    FStatusesTabs.AddSpeechTab(tab.TabID, 0);
  end;

  UpdateTabs(false);
end;

procedure TFormMainTweetVoice.ActionSpeakExecute(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  tab: TXMLStatusesTab;
  Status: TXMLStatus;
begin
  Node := GetSelectedNode;
  tab := FStatusesTabs[TabControl.TabIndex];

  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    Status := dataPtr.Status;
    RequestSpeech(Status, tab.TabID);
    FStatusesTabs.SetSpeechTab(tab.TabID, Status.ID);
  end
  else
  begin
    FStatusesTabs.SetSpeechTab(tab.TabID, 0);
  end;

  UpdateTabs(false);
end;

procedure TFormMainTweetVoice.ActionSpeakRemoveExecute(Sender: TObject);
var
  tab: TXMLStatusesTab;
begin
  tab := FStatusesTabs[TabControl.TabIndex];
  FStatusesTabs.RemoveSpeechTab(tab.TabID);
  UpdateTabs(false);
end;

procedure TFormMainTweetVoice.ClearTreeNodes;
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  FSelectedNode := nil;
  Node := VirtualTreeView.RootNode.FirstChild;
  while (Node <> nil) do
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    dataPtr.SourceRectView.Free;
    dataPtr.TextRectView.Free;
    dataPtr.UserRectView.Free;
    Node := Node.NextSibling;
  end;

  VirtualTreeView.Clear;
end;

procedure TFormMainTweetVoice.ComboBoxFindWordChange(Sender: TObject);
begin
  UpdateUI;
end;

procedure TFormMainTweetVoice.ComboBoxFindWordKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_RETURN) then
  begin
    if (ssShift in Shift) then
    begin
      ActionFindPreviousExecute(Sender);
    end
    else
    begin
      ActionFindNextExecute(Sender);
    end;

    Key := 0;
  end;
end;

procedure TFormMainTweetVoice.ComboBoxPostUserNamesChange(Sender: TObject);
begin
  UpdateUI;
end;

procedure TFormMainTweetVoice.ComboBoxUserNamesChange(Sender: TObject);
var
  pt: TPoint;
  userInfo: TUserDigestInfo;
  Rect: TRect;
begin
  HideHintWindow;
  if Assigned(UserDigestInfos) then
  begin
    // if (UserDigestInfos.Infos.TryGetValue(Lowercase(ComboBoxUserNames.Text), userInfo)) then
    if (XMLUserManager.GetUserDigestInfo(LowerCase(ComboBoxUserNames.Text), userInfo)) then
    begin
      pt := ComboBoxUserNames.ClientToScreen(Point(0, -ComboBoxUserNames.Height - 5));

      Rect := FHintWnd.CalcHintRect(1000, userInfo.GetName, nil);
      Rect.Left := Rect.Left + pt.X;
      Rect.Right := Rect.Right + pt.X;
      Rect.Top := Rect.Top + pt.Y;
      Rect.Bottom := Rect.Bottom + pt.Y;

      FHintWnd.ActivateHint(Rect, userInfo.GetName);
    end;
  end;

end;

procedure TFormMainTweetVoice.ComboBoxUserNamesExit(Sender: TObject);
begin
  ComboBoxUserNames.Hide;
  HideHintWindow;
end;

procedure TFormMainTweetVoice.ComboBoxUserNamesKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) then
  begin
    Key := 0;
    ComboBoxUserNames.Hide;
    HideHintWindow;
    MemoPostMessage.SetFocus;
  end;
  if (Key = VK_RETURN) then
  begin
    Key := 0;
    MemoPostMessage.SelText := '@' + ComboBoxUserNames.Text;
    HideHintWindow;
    ComboBoxUserNames.Hide;
    MemoPostMessage.SetFocus;
  end;
end;

procedure TFormMainTweetVoice.EditChange(Sender: TObject);
var
  leftCharCount: Integer;
begin
  leftCharCount := 140 - Length(MemoPostMessage.Text);
  LabelLeftCharCount.Caption := IntToStr(leftCharCount);
  if (leftCharCount < 0) then
  begin
    LabelLeftCharCount.Font.Color := clRed;
    LabelLeftCharCount.Font.Style := [fsBold];
  end
  else
  begin
    LabelLeftCharCount.Font.Color := clWindowText;
    LabelLeftCharCount.Font.Style := [];
  end;
  UpdateUI;
end;

procedure TFormMainTweetVoice.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UserConfig.FormMainRect.Left := Left;
  UserConfig.FormMainRect.Top := Top;
  UserConfig.FormMainRect.Width := Width;
  UserConfig.FormMainRect.Height := Height;
  UserConfig.PanelPostVisible := PanelPost.Visible;
  GetConfigFromTreeView(UserConfig.FormMainListViewColumns, VirtualTreeView);
end;

procedure TFormMainTweetVoice.FormCreate(Sender: TObject);
var
  tab: TXMLStatusesTab;
  tabConfig: TTabConfig;
  i: Integer;
begin
  FHintWnd := THintWindow.Create(Self);

  FStatusesTabs := TXMLStatusesTabList.Create;
  FSavedSearches := TObjectList<TXMLSearch>.Create;
  if (UserConfig.TabConfigs.Count = 0) then
  begin
    // z[ǉ
    tab := TXMLStatusesTab.Create;
    tab.TabType := ttHomeTimeline;
    // tab.IsSpeechTab := true;
    FStatusesTabs.Add(tab);

    // ԐMǉ
    tab := TXMLStatusesTab.Create;
    tab.TabType := ttReplies;
    FStatusesTabs.Add(tab);

    // _CNgbZ[Wǉ
    tab := TXMLStatusesTab.Create;
    tab.TabType := ttDirectMessages;
    FStatusesTabs.Add(tab);

    // Cɓǉ
    tab := TXMLStatusesTab.Create;
    tab.TabType := ttFavorites;
    FStatusesTabs.Add(tab);
  end
  else
  begin
    for i := 0 to UserConfig.TabConfigs.Count - 1 do
    begin
      tabConfig := UserConfig.TabConfigs.Items[i] as TTabConfig;
      tab := TXMLStatusesTab.Create(tabConfig);
      FStatusesTabs.Add(tab);
    end;
  end;

  FWhiteBitmap := TBitmap.Create;
  FWhiteBitmap.PixelFormat := pf32bit;
  FWhiteBitmap.Width := 16;
  FWhiteBitmap.Height := 16;

  FRegExpScreenName := TPerlRegEx.Create(nil);
  FRegExpScreenName.RegEx := '@([\w_\d]+)';

  FRequestedScreenNames := TDictionary<string, Integer>.Create;
  VirtualTreeView.NodeDataSize := Sizeof(TTreeData);

  FImageDownloader := TImageDownloader.Create(Self);
  FImageDownloader.Start;
  FCommunicator := TCommunicator.Create(Self);
  FCommunicator.Start;
  FAuxCommunicator := TCommunicator.Create(Self);
  FAuxCommunicator.Start;
  FSpeechThread := TSpeechThread.Create(Self);
  FSpeechThread.Start;

  // XMLUserManager.GetUsersFromDatabase; //NɑSǂނ̂͂߂

  menuItemPauseSpeech.ImageIndex := -1; // ACR
  menuItemAutoRefresh.ImageIndex := -1; // ACR
  menuItemSetBalloon.ImageIndex := -1; // ACR
  menuItemSetCaptionNormal.ImageIndex := -1; // ACR
  menuItemSetCaptionWindow.ImageIndex := -1; // ACR
  menuItemMuteSpeech.ImageIndex := -1; // ACR
  ButtonFindNext.Caption := '';
  ButtonFindPrevious.Caption := '';

end;

procedure TFormMainTweetVoice.FormDestroy(Sender: TObject);
var
  i: Integer;
  tab: TXMLStatusesTab;
begin
  UserConfig.TabConfigs.Clear;
  for i := 0 to FStatusesTabs.Items.Count - 1 do
  begin
    tab := FStatusesTabs.Tabs[i];
    tab.CreateConfig(UserConfig.TabConfigs);
  end;

  DBManager.Commit;
  FFormClosing := true;
  FImageDownloader.TerminateAndWaitFor;
  FImageDownloader.Free;
  FAuxCommunicator.TerminateAndWaitFor;
  FAuxCommunicator.Free;
  FCommunicator.TerminateAndWaitFor;
  FCommunicator.Free;
  FSpeechThread.TerminateAndWaitFor;
  FSpeechThread.Free;
  ClearTreeNodes;
  FRequestedScreenNames.Free;
  FRegExpScreenName.Free;
  FWhiteBitmap.Free;
  FStatusesTabs.Free;
  FSavedSearches.Free;
  TUserConfig.SaveUserConfig;
end;

procedure TFormMainTweetVoice.FormShow(Sender: TObject);
var
  i: Integer;
  userAuth: TUserAuth;
begin
  if (UserConfig.IsLoaded) then
  begin
    Left := UserConfig.FormMainRect.Left;
    Top := UserConfig.FormMainRect.Top;
    Width := UserConfig.FormMainRect.Width;
    Height := UserConfig.FormMainRect.Height;

    SetConfigToTreeView(UserConfig.FormMainListViewColumns, VirtualTreeView);
    ActionShowPanelPost.Checked := UserConfig.PanelPostVisible;
  end;

  if (UserConfig.ListViewFont.FontName = '') then
  begin
    UserConfig.ListViewFont.FontName := VirtualTreeView.Font.Name;
    UserConfig.ListViewFont.FontSize := VirtualTreeView.Font.Size;
  end;

  for i := 0 to UserConfig.UserOAuths.Count - 1 do
  begin
    userAuth := UserConfig.UserOAuths.Items[i] as TUserAuth;
    if (userAuth.UserName = AnsiString(UserConfig.DefaultUserName)) then
    begin
      TwitterAuth.OAuthToken := string(userAuth.OAuthToken);
      TwitterAuth.OAuthTokenSecret := string(userAuth.OAuthTokenSecret);
      break;
    end;
  end;

  if (TwitterAuth.OAuthToken = '') or (UserConfig.ShowFormLoginStartUp) then
  begin
    if (FormLogin.ShowModal = mrOK) then
    begin
    end
    else
    begin
      Close;
      Exit;
    end;
  end;

  // TabControlXV
  UpdateTabs;

  UserConfig.ApplyFontSizeToForms;
  FLogined := true;
  Caption := 'TweetVoice - @' + UserConfig.DefaultUserName;
  RequestFriends;
  FStatusesTabs.RequestStatuses(Self, FCommunicator);
  RequestLists(UserConfig.DefaultUserName);
  RequestSavedSearches;
  UpdateStatusPanel0;
  UpdateUI;
  UpdateVirtualTreeView;
  FormCaption.UpdateUI;
  FormOptions.PageControl.TabIndex := 0;
  // VirtualTreeView.SetFocus;
end;

function TFormMainTweetVoice.GetSelectedNode: PVirtualNode;
var
  Node: PVirtualNode;
begin
  Result := nil;
  Node := VirtualTreeView.RootNode.FirstChild;
  while (Node <> nil) do
  begin
    if (VirtualTreeView.Selected[Node]) then
    begin
      Result := Node;
      break;
    end;
    Node := Node.NextSibling;
  end;
end;

function TFormMainTweetVoice.GetSelectedNodes: TList<PVirtualNode>;
var
  Node: PVirtualNode;
begin
  Result := TList<PVirtualNode>.Create;
  Node := VirtualTreeView.RootNode.FirstChild;
  while (Node <> nil) do
  begin
    if (VirtualTreeView.Selected[Node]) then
    begin
      Result.Add(Node);
    end;
    Node := Node.NextSibling;
  end;
end;

procedure TFormMainTweetVoice.HideHintWindow;
var
  Rect: TRect;
begin
  Rect.Top := 0;
  Rect.Left := 0;
  Rect.Bottom := 0;
  Rect.Right := 0;

  FHintWnd.ActivateHint(Rect, '');
end;

procedure TFormMainTweetVoice.MemoPostMessageKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_RETURN) then
  begin
    if (ssShift in Shift) then
    begin
      ButtonPostClick(Sender);
    end;
    Key := 0;
  end;
end;

procedure TFormMainTweetVoice.MemoPostMessageKeyPress(Sender: TObject; var Key: Char);
var
  userInfo: TUserDigestInfo;
  userInfos: TList<TUserDigestInfo>;
  pt: TPoint;
  strings: TStringList;
begin
  if (Key = '@') and (UserConfig.ComplementScreenName) then
  begin
    GetCaretPos(pt);

    ComboBoxUserNames.Left := pt.X + MemoPostMessage.Left + 3;
    ComboBoxUserNames.Top := pt.Y + MemoPostMessage.Top;
    ComboBoxUserNames.Text := '';
    ComboBoxUserNames.Items.Clear;
    strings := TStringList.Create;
    Screen.Cursor := crHourGlass;

    // FormLogs.AddLogText('----', Self.ClassName);
    try
      if Not Assigned(UserDigestInfos) then
      begin
        UserDigestInfos := DBManager.SelectAllUsers;
      end;
      userInfos := XMLUserManager.GetUserDigestInfos;
      try
        strings.Capacity := userInfos.Count;
        for userInfo in userInfos do
        begin
          // FormLogs.AddLogText('screenName=' + userInfo.ScreenName, Self.ClassName);

          strings.Add(userInfo.ScreenName);
        end;
        strings.Sort;
        ComboBoxUserNames.Items.Assign(strings);
      finally
        userInfos.Free;
      end;
    finally
      Screen.Cursor := crDefault;
      strings.Free;
    end;

    ComboBoxUserNames.Show;
    ComboBoxUserNames.BringToFront;
    ComboBoxUserNames.SetFocus;
    Key := #0;
  end;
end;

procedure TFormMainTweetVoice.menuItemListsClick(Sender: TObject);
var
  menuItem: TMenuItem;
  RegExp: TPerlRegEx;
  UserName, listName: string;
  tab: TXMLStatusesTab;
begin
  menuItem := Sender as TMenuItem;
  RegExp := TPerlRegEx.Create(nil);
  try
    RegExp.RegEx := '@([\w_\d]+)\/([\w_\d]+)\/(\w+)';
    RegExp.Options := [preCaseLess];
    RegExp.Subject := menuItem.Hint;
    if (RegExp.Match) then
    begin
      UserName := RegExp.SubExpressions[1];
      listName := RegExp.SubExpressions[2];

      tab := TXMLStatusesTab.Create;
      tab.TabType := ttList;
      tab.UserName := UserName;
      tab.listName := listName;
      tab.IsPublicMode := (RegExp.SubExpressions[3] = 'public');
      FStatusesTabs.Add(tab);
      UpdateTabs;
      tab.RequestStatuses(Self, FCommunicator);
      TabControl.TabIndex := FStatusesTabs.IndexOfTabID(tab.TabID);
      UpdateVirtualTreeView;
      UpdateUI;
      UpdateStatusPanel0;
    end;

  finally
    RegExp.Free;
  end;
end;

procedure TFormMainTweetVoice.menuItemSearchClick(Sender: TObject);
var
  menuItem: TMenuItem;
  tab: TXMLStatusesTab;
begin
  menuItem := Sender as TMenuItem;

  tab := TXMLStatusesTab.Create;
  tab.TabType := ttSearch;
  tab.SearchWord := menuItem.Hint;
  FStatusesTabs.Add(tab);
  UpdateTabs;
  tab.RequestStatuses(Self, FCommunicator);
  TabControl.TabIndex := FStatusesTabs.IndexOfTabID(tab.TabID);
  UpdateVirtualTreeView;
  UpdateUI;
  UpdateStatusPanel0;
end;

procedure TFormMainTweetVoice.menuItemToolOptionsClick(Sender: TObject);
begin
  FormOptions.GetFromUserConfig;
  if (FormOptions.ShowModal = mrOK) then
  begin
    FormOptions.SetToUserConfig;
    FormCaption.UpdateCaption;
    UserConfig.ApplyFontSizeToForms;
  end;
end;

procedure TFormMainTweetVoice.PopupMenuTabPopup(Sender: TObject);
begin
  UpdateUI;
end;

procedure TFormMainTweetVoice.RequestSavedSearches;
var
  request: TCommRequestSavedSearches;
begin
  request := TCommRequestSavedSearches.Create(Self);
  FAuxCommunicator.Enqueue(request);
end;

procedure TFormMainTweetVoice.RequestSpeech(ARequest: TSpeechRequest);
begin
  // ARequest.Status.RetweetedStatus.IsRead := true;
  UpdateTabs(false);
  FSpeechThread.Speak(ARequest);
end;

procedure TFormMainTweetVoice.RequestSpeech(AStatus: TXMLStatus; ATabID: Integer);
var
  request: TSpeechRequest;
begin
  request := TSpeechRequest.Create;
  request.Status := AStatus;
  request.TabID := ATabID;
  RequestSpeech(request);
end;

procedure TFormMainTweetVoice.RemoveVirtualTreeViewNode(AStatus: TXMLStatus);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
begin
  Node := VirtualTreeView.RootNode.FirstChild;
  while (Node <> nil) do
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    if (dataPtr.Status = AStatus) then
    begin
      dataPtr.SourceRectView.Free;
      dataPtr.TextRectView.Free;
      dataPtr.UserRectView.Free;
      VirtualTreeView.DeleteNode(Node);
      break;
    end;
    Node := Node.NextSibling;
  end;
end;

procedure TFormMainTweetVoice.RepaintNode(AStatusID: Int64);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  // tab: TXMLStatusesTab;
begin
  Node := VirtualTreeView.RootNode.FirstChild;
  while (Node <> nil) do
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    if (AStatusID = dataPtr.Status.ID) then
    begin
      VirtualTreeView.RepaintNode(Node);
    end;
    Node := Node.NextSibling;
  end;
end;

procedure TFormMainTweetVoice.RequestActiveStatuses;
var
  index: Integer;
begin
  if (Not FLogined) then
  begin
    Exit;
  end;
  index := TabControl.TabIndex;

  FStatusesTabs[index].RequestStatuses(Self, FCommunicator);
  UpdateStatusPanel0;
end;

procedure TFormMainTweetVoice.RequestCreateFavorite(AID: Int64);
var
  request: TCommRequestCreateFavorite;
  tab: TXMLStatusesTab;
begin
  request := TCommRequestCreateFavorite.Create(Self);
  request.url := Format('1/favorites/%s/%s.xml', [request.keyword, IntToStr(AID)]);
  for tab in FStatusesTabs.Items do
  begin
    if (tab.TabType = ttFavorites) then
    begin
      request.TabID := tab.TabID;
    end;
  end;
  FAuxCommunicator.Enqueue(request);
end;

procedure TFormMainTweetVoice.RequestFriendship(AScreenName: string; AUserID: Int64; AIsCreation: Boolean);
var
  request: TCommRequestFriendShip;
begin
  request := TCommRequestFriendShip.Create(Self);
  request.ScreenName := AScreenName;
  request.UserID := AUserID;
  request.IsCreation := AIsCreation;
  FAuxCommunicator.Enqueue(request);
end;

procedure TFormMainTweetVoice.RequestDestroyFavorite(AID: Int64);
var
  request: TCommRequestDestroyFavorite;
  tab: TXMLStatusesTab;
begin
  request := TCommRequestDestroyFavorite.Create(Self);
  request.url := Format('1/favorites/%s/%s.xml', [request.keyword, IntToStr(AID)]);
  for tab in FStatusesTabs.Items do
  begin
    if (tab.TabType = ttFavorites) then
    begin
      request.TabID := tab.TabID;
    end;
  end;
  FAuxCommunicator.Enqueue(request);
end;

procedure TFormMainTweetVoice.RequestFriends;
var
  request: TCommRequestFriendsIDs;
begin
  request := TCommRequestFriendsIDs.Create(Self);
  request.ScreenName := UserConfig.DefaultUserName;
  FAuxCommunicator.Enqueue(request);
end;

procedure TFormMainTweetVoice.RequestLists(AScreenName: string);
var
  request: TCommRequestLists;
  url: string;
begin
  request := TCommRequestLists.Create(Self);
  url := '1/' + AScreenName + '/lists.xml';
  request.url := url;
  FAuxCommunicator.Enqueue(request);
end;

// procedure TFormMainTweetVoice.RequestUserShow(AScreenName: string);
// var
// request: TCommRequestUser;
// url: string;
// begin
// request := TCommRequestUser.Create(Self);
// url := '1/users/show.xml?screen_name=' + AScreenName;
// request.url := url;
// FAuxCommunicator.Enqueue(request);
//
// end;

procedure TFormMainTweetVoice.RequestUsersLookup(AScreenNames: string);
var
  request: TCommRequestLookupUsers;
begin
  if (AScreenNames <> '') then
  begin
    request := TCommRequestLookupUsers.Create(Self);
    request.url := '1/users/lookup.xml';

    FormLogs.AddLogText('RequestUsersLookup ' + AScreenNames, Self.ClassName);
    request.Parameters.Add('screen_name=' + TOAuthUtil.urlEncodeRawRFC3986(AScreenNames));
    FAuxCommunicator.Enqueue(request);
  end;
end;

procedure TFormMainTweetVoice.SetBitmaps(AUrlBitmaps: TList<TUrlBitmap>);
begin
  if (FFormClosing) then
    Exit;

  FormUsers.SetBitmaps(AUrlBitmaps);
  VirtualTreeView.Refresh;
end;

procedure TFormMainTweetVoice.SetCommunicatorResult(ARequest: TCommRequest);
var
  User: TXMLUser;
  Status: TXMLStatus;
  s: string;
  i: Integer;
  ScreenName: string;
  urlBitmap: TUrlBitmap;
  rateLimit: TCommRateLimiteStatus;
  RequestLists: TCommRequestLists;
  RequestSavedSearch: TCommRequestSavedSearches;
  RequestSavedSearchOperation: TCommRequestSavedSearchesOperation;
  RequestUser: TCommRequestUser;
  isActiveTabRequest: Boolean;
  TabIndex: Integer;
  menuItem: TMenuItem;
  list: TXMLList;
  search: TXMLSearch;
  newSearch: TXMLSearch;
  dataPtr: PTreeData;
  Node: PVirtualNode;
  ScreenNames: string;
begin
  if (FFormClosing) then
    Exit;

  ScreenNames := '';
  if (ARequest is TCommRequestStatuses) or (ARequest is TCommUpdateStatus) or
    ((ARequest is TCommRequestCreateFavorite) or (ARequest is TCommRetweetStatus)) then
  begin
    // 摜_E[hv
    for User in XMLUserManager.NameUsers.Values do
    begin
      if Not Assigned(User.ProfileImage) and (Not User.ProfileImageRequested) and (User.ID <> 0) then
      begin
        urlBitmap := TUrlBitmap.Create;
        urlBitmap.User := User;
        FImageDownloader.EnqueueUrl(urlBitmap);
        User.ProfileImageRequested := true;
      end;
    end;

    TabIndex := FStatusesTabs.IndexOfTabID(ARequest.TabID);
    isActiveTabRequest := (TabIndex = TabControl.TabIndex);
    FStatusesTabs.ReceiveStatuses(ARequest);

    VirtualTreeView.BeginUpdate;

    // ANeBu^u̗vȂm[hǉ
    if (isActiveTabRequest) and (ARequest is TCommRequestDestroyFavorite) and (ARequest.Statuses.Count > 0) then
    begin
      RemoveVirtualTreeViewNode(ARequest.Statuses[0]);
    end;

    for Status in ARequest.AddedStatuses do
    begin
      // ANeBu^u̗vȂm[hǉ
      if (isActiveTabRequest) then
      begin
        if Not(ARequest is TCommRequestDestroyFavorite) then
        begin
          AddVirtualTreeViewNode(Status);
        end;
      end;

      // ̏ꍇ[U񂪕sĂ邽߁Aŗv
      if (Status.User.Name = '') then
      begin
        ScreenName := Status.User.ScreenName;
        if (Not FRequestedScreenNames.ContainsKey(ScreenName)) then
        begin
          FRequestedScreenNames.Add(ScreenName, 0);
          Utils.AddCommaSeparatedString(ScreenNames, LowerCase(ScreenName));
        end;
      end;

      if (Status.GetRetweetedStatus.User.Name = '') then
      begin
        ScreenName := Status.GetRetweetedStatus.User.ScreenName;
        if (Not FRequestedScreenNames.ContainsKey(ScreenName)) then
        begin
          FRequestedScreenNames.Add(ScreenName, 0);
          Utils.AddCommaSeparatedString(ScreenNames, LowerCase(ScreenName));
        end;
      end;

      // Status.TextAm̃[Uv;
      FRegExpScreenName.Subject := Status.Text;
      while (FRegExpScreenName.MatchAgain) do
      begin
        ScreenName := LowerCase(FRegExpScreenName.SubExpressions[1]);
        User := XMLUserManager.GetUser(ScreenName);
        if (Not Assigned(User)) and (Not FRequestedScreenNames.ContainsKey(ScreenName)) then
        begin
          FRequestedScreenNames.Add(ScreenName, 0);
          Utils.AddCommaSeparatedString(ScreenNames, LowerCase(ScreenName));
        end;
      end;
      if (Length(ScreenNames) > 100) then
      begin
        RequestUsersLookup(ScreenNames);
        ScreenNames := '';
      end;
    end;

    RequestUsersLookup(ScreenNames);
    VirtualTreeView.EndUpdate;
    VirtualTreeView.Sort(nil, VirtualTreeView.Header.SortColumn, VirtualTreeView.Header.SortDirection);
    UpdateStatusPanel0;

    if (ARequest.ExceptionMessage <> '') then
    begin
      s := ARequest.ExceptionMessage;
    end
    else
    begin
      if (ARequest.Statuses.Count = 0) then
      begin
        s := 'VcC[g͂܂';
      end
      else
      begin
        if (ARequest.IsOlder) then
        begin
          s := 'ÂcC[g' + IntToStr(ARequest.Statuses.Count) + '';
        end
        else
        begin
          s := 'VcC[g' + IntToStr(ARequest.Statuses.Count) + '';
        end;
      end;
    end;

    s := s + FormatDateTime('  hh:nn:ssXV', Now);
    if (TabIndex >= 0) then
    begin
      FStatusesTabs[TabIndex].StatusPanelText := s;
    end;

    UpdateStatusPanel1;
  end
  else if (ARequest is TCommRateLimiteStatus) then
  begin
    rateLimit := ARequest as TCommRateLimiteStatus;
    FormAbout.MemoRateLimiteStatus.Lines.Add(Format('API Limitation %d/%d', [rateLimit.Hash.RemainingHits,
        rateLimit.Hash.HourlyLimit]));
    FormAbout.MemoRateLimiteStatus.Lines.Add('Reset Time ' + FormatDateTime('yy/mm/dd hh:nn:ss',
        rateLimit.Hash.LocalResetTime));
  end
  else if (ARequest is TCommRequestLists) then
  begin
    RequestLists := ARequest as TCommRequestLists;

    if Assigned(RequestLists.Lists) then
    begin
      menuItemLists.Clear;
      menuItemLists.Enabled := false;
      for list in RequestLists.Lists do
      begin
        menuItemLists.Enabled := true;
        menuItem := TMenuItem.Create(Self);
        menuItem.Caption := list.Name;
        menuItem.Hint := list.FullName + '/' + list.Mode;
        menuItem.OnClick := menuItemListsClick;
        if list.Mode <> 'public' then
        begin
          menuItem.ImageIndex := 21;
        end;
        menuItemLists.Add(menuItem);
      end;
    end;
  end
  else if (ARequest is TCommRequestSavedSearches) then
  begin
    RequestSavedSearch := ARequest as TCommRequestSavedSearches;
    if Assigned(RequestSavedSearch.Searches) then
    begin
      menuItemSavedSearch.Clear;
      menuItemSavedSearch.Enabled := false;

      FSavedSearches.Free;
      FSavedSearches := TObjectList<TXMLSearch>.Create;
      for search in RequestSavedSearch.Searches do
      begin
        menuItemSavedSearch.Enabled := true;
        menuItem := TMenuItem.Create(Self);
        menuItem.Caption := search.Name;
        menuItem.Hint := search.Query;
        menuItem.OnClick := menuItemSearchClick;
        menuItemSavedSearch.Add(menuItem);
        FSavedSearches.Add(search);
      end;

    end;
  end
  else if (ARequest is TCommRequestSavedSearchesOperation) then
  begin
    RequestSavedSearchOperation := ARequest as TCommRequestSavedSearchesOperation;

    if Assigned(RequestSavedSearchOperation.search) then
    begin
      if (RequestSavedSearchOperation.IsCreation) then
      begin
        menuItem := TMenuItem.Create(Self);
        menuItem.Caption := RequestSavedSearchOperation.search.Name;
        menuItem.Hint := RequestSavedSearchOperation.search.Query;
        menuItem.OnClick := menuItemSearchClick;
        menuItemSavedSearch.Add(menuItem);
        newSearch := TXMLSearch.Create(ARequest.XMLParser);
        newSearch.CopyFrom(RequestSavedSearchOperation.search);
        FSavedSearches.Add(newSearch);
      end
      else
      begin
        for i := 0 to menuItemSavedSearch.Count - 1 do
        begin
          menuItem := menuItemSavedSearch.Items[i];
          if (CompareText(menuItem.Hint, RequestSavedSearchOperation.search.Query) = 0) then
          begin
            menuItemSavedSearch.Delete(i);
            break;
          end;
        end;
        for i := 0 to FSavedSearches.Count - 1 do
        begin
          if (FSavedSearches[i].ID = RequestSavedSearchOperation.search.ID) then
          begin
            FSavedSearches.Delete(i);
            break;
          end;
        end;
        // FreeAndNil(RequestSavedSearchOperation.search);
      end;
    end;
  end
  else if (ARequest is TCommRequestFriendsIDs) then
  begin
    if (ARequest.ExceptionMessage <> '') then
    begin
      RequestFriends;
    end
    else
    begin
      VirtualTreeView.Refresh;
      ComboBoxPostUserNames.Items.Assign(TCommRequestFriendsIDs(ARequest).Friends);
    end;
  end
  else if (ARequest is TCommRequestUser) then
  begin
    // 󂯎[Ũm[hŕ`
    VirtualTreeView.BeginUpdate;
    RequestUser := ARequest as TCommRequestUser;

    Node := VirtualTreeView.RootNode.FirstChild;
    while (Node <> nil) do
    begin
      dataPtr := VirtualTreeView.GetNodeData(Node);
      if (RequestUser.User = dataPtr.Status.User) then
      begin
        dataPtr.UserRectView.Free;
        dataPtr.UserRectView := RequestUser.User.CreateUserRectView;
        dataPtr.UserRectView.Canvas := VirtualTreeView.Canvas;
        dataPtr.UserRectView.ArrangeLayout(VirtualTreeView.Header.Columns[1].Width);
        // VirtualTreeView.RepaintNode(Node);
      end;
      Node := Node.NextSibling;
    end;
    VirtualTreeView.EndUpdate;

  end
  else if (ARequest is TCommRequestLookupUsers) then
  begin
    // 󂯎[Ũm[hŕ`
    VirtualTreeView.BeginUpdate;
    try
      try
        Node := VirtualTreeView.RootNode.FirstChild;
        while (Node <> nil) do
        begin
          dataPtr := VirtualTreeView.GetNodeData(Node);
          if (ARequest.Users.Contains(dataPtr.Status.User)) then
          begin
            FreeAndNil(dataPtr.UserRectView);
            // FormLogs.AddLogText('1', Self.ClassName);
            dataPtr.UserRectView := dataPtr.Status.User.CreateUserRectView;
            // FormLogs.AddLogText('2', Self.ClassName);
            dataPtr.UserRectView.Canvas := VirtualTreeView.Canvas;
            // FormLogs.AddLogText('3', Self.ClassName);
            dataPtr.UserRectView.ArrangeLayout(VirtualTreeView.Header.Columns[1].Width);
            // FormLogs.AddLogText('4', Self.ClassName);
            // VirtualTreeView.RepaintNode(Node);
          end;
          Node := Node.NextSibling;
        end;

      except
        on E: Exception do
        begin
          FormLogs.AddLogText(E.Message, Self.ClassName);
        end;
      end;

    finally
      VirtualTreeView.EndUpdate;
    end;
  end;

  FormUsers.SetCommunicatorResult(ARequest);
  ARequest.Free;
  UpdateTabs(false);
end;

procedure TFormMainTweetVoice.ShowBalloonHit(AStatus: TXMLStatus);
begin
  TrayIcon.BalloonTitle := AStatus.User.Name;
  TrayIcon.BalloonHint := AStatus.Text;
  TrayIcon.ShowBalloonHint;
end;

procedure TFormMainTweetVoice.SpeakCompleted(ARequest: TSpeechRequest);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  // tab: TXMLStatusesTab;
  ID: Int64;
begin
  // ǂݏグI
  Node := VirtualTreeView.RootNode.FirstChild;
  while (Node <> nil) do
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    if (dataPtr.Status = ARequest.Status) then
    begin
      VirtualTreeView.RepaintNode(Node);
    end;
    Node := Node.NextSibling;
  end;

  // tab := GetSpeechTab;
  // if Assigned(tab) then
  // begin
  // tab.LastSpeechStatusID := ARequest.Status.ID;
  // end;

  ID := FStatusesTabs[TabControl.TabIndex].LastSpeechStatusID;
  FStatusesTabs.SetLastSpeechStatusID(ARequest.Status.ID, ARequest.TabID);
  RepaintNode(ID);

  FAutoSpeechStartingTime := DateUtils.IncSecond(Now, ARequest.WaitingTimeSec);
  ARequest.Free;
  UpdateTabs(false);
end;

procedure TFormMainTweetVoice.TabControlChange(Sender: TObject);
begin
  UpdateVirtualTreeView;
  UpdateStatusPanel0;
  UpdateUI;
  VirtualTreeView.SetFocus;
end;

procedure TFormMainTweetVoice.TabControlDrawTab(Control: TCustomTabControl; TabIndex: Integer; const Rect: TRect;
  Active: Boolean);
var
  ImageIndex: Integer;
  offsetX: Integer;
  offsetY: Integer;
  alpha: Integer;
  // Status: TXMLStatus;
  ForeColor: TColor;
  ID: Int64;
  r: TRect;
  tf: TTextFormat;
  s: string;
  tab: TXMLStatusesTab;
begin
  if (Active) then
  begin
    Control.Canvas.Brush.Color := clWhite;
    Control.Canvas.FillRect(Rect);
  end;
  ID := FSpeechThread.GetSpeakingStatusID;

  ForeColor := TabControl.Font.Color;

  tab := nil;
  if (FStatusesTabs.Items.Count > TabIndex) then
  begin
    tab := FStatusesTabs[TabIndex];
    if (tab.IsSpeechTab) and (tab.ContainsStatus(ID)) then
    begin
      if (FBlinkAlpha > 200) then
      begin
        alpha := 400 - FBlinkAlpha;
      end
      else
      begin
        alpha := FBlinkAlpha;
      end;
      ForeColor := RGB(0, alpha, alpha);
    end;
  end;

  Control.Canvas.Font.Color := ForeColor;
  TabControlGetImageIndex(Control, TabIndex, ImageIndex);
  offsetX := 2;
  offsetY := 0;

  if (ImageIndex >= 0) then
  begin
    if (tab.UpdatingStatuses) then
    begin
      ImageListTabs.Draw(Control.Canvas, Rect.Left + offsetX, Rect.Top + offsetY, 2 + (FCommIconProgress
          { div 2 } ) mod 8);
    end
    else
    begin
      ImageListTabs.Draw(Control.Canvas, Rect.Left + offsetX, Rect.Top + offsetY, ImageIndex);
    end;
    offsetX := 22;
  end;

  if Assigned(tab) then
  begin
    r := Rect;
    r.Left := Rect.Left + offsetX;
    r.Top := Rect.Top + offsetY + 2;
    tf := [tfNoPrefix, tfSingleLine, tfEndEllipsis];
    s := tab.DisplayName;
    Control.Canvas.TextRect(r, s, tf);
  end;
end;

procedure TFormMainTweetVoice.TabControlGetImageIndex(Sender: TObject; TabIndex: Integer; var ImageIndex: Integer);
begin
  if Assigned(FStatusesTabs) and (FStatusesTabs.Items.Count > TabIndex) then
  begin
    if (FStatusesTabs[TabIndex].IsSpeechTab) then
    begin
      if (ActionPauseSpeech.Checked) then
      begin
        ImageIndex := 0;
      end
      else
      begin
        ImageIndex := 1;
      end;
    end
    else if (FStatusesTabs[TabIndex].UpdatingStatuses) then
    begin
      ImageIndex := 2; // lɈӖ͂Ȃ
    end
    else
    begin
      ImageIndex := -1;
    end;
  end;
end;

procedure TFormMainTweetVoice.TabControlMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  idx: Integer;
begin
  if (Button = mbRight) then
  begin
    idx := TabControl.IndexOfTabAt(X, Y);
    if (idx >= 0) and (TabControl.TabIndex <> idx) then
    begin
      TabControl.TabIndex := idx;
      UpdateVirtualTreeView;
      UpdateUI;
      // UpdateTabs(false);
    end;

  end;
end;

procedure TFormMainTweetVoice.TimerBlinkTimer(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Rect: TRect;
  idx: Integer;
  tab: TXMLStatusesTab;
begin
  if (FFormClosing) then
    Exit;

  Inc(FCommIconProgress);

  Inc(FAddedLineX);
  if (FAddedLineX > 4) then
  begin
    FAddedLineX := 0;
  end;
  Inc(FBlinkAlpha, 40);
  if (FBlinkAlpha > 400) then
  begin
    FBlinkAlpha := 0;
  end;
  Node := VirtualTreeView.RootNode.FirstChild;
  while (Node <> nil) do
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    if (FSpeechThread.IsSpeaking(dataPtr.Status)) then
    begin
      VirtualTreeView.RepaintNode(Node);
      // break;
    end;
    // if (dataPtr.Status.ID = FStatusesTabs[TabControl.TabIndex].LastSpeechStatusID) then
    // begin
    // VirtualTreeView.RepaintNode(Node);
    // end;
    Node := Node.NextSibling;
  end;
  idx := 0;
  for tab in FStatusesTabs.Items do
  begin
    if (tab.IsSpeechTab) or (tab.UpdatingStatuses) then
    begin
      Rect := TabControl.TabRect(idx);
      InvalidateRect(TabControl.Handle, Rect, true);
    end;
    Inc(idx);
  end;
end;

procedure TFormMainTweetVoice.TimerTimer(Sender: TObject);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  Status: TXMLStatus;
  TargetNode: PVirtualNode;
  ID: Int64;
  // tab: TXMLStatusesTab;
begin
  if (FLogined) and (UserConfig.AutoRefresh) then
  begin
    FStatusesTabs.RequestStatusesOnTimer(Self, FCommunicator);
  end;

  if (Not FSpeechThread.IsSpeaking) and (Not UserConfig.PauseSpeech) and (FAutoSpeechStartingTime < Now) then
  begin
    TargetNode := nil;
    // tab := GetSpeechTab;
    Status := FStatusesTabs.GetNextSpeechStatus;
    Node := VirtualTreeView.RootNode.FirstChild;
    while (Node <> nil) do
    begin
      dataPtr := VirtualTreeView.GetNodeData(Node);
      if (dataPtr.Status = Status) then
      begin
        TargetNode := Node;
        break;
      end;
      Node := Node.NextSibling;
    end;

    if Assigned(Status) then
    begin
      RequestSpeech(Status, FStatusesTabs.GetLastSpeechTabID);
      if Assigned(TargetNode) then
      begin
        VirtualTreeView.RepaintNode(TargetNode);
      end;
      ID := FStatusesTabs[TabControl.TabIndex].LastSpeechStatusID;
      RepaintNode(ID);
    end;
  end;

  if (Not FSpeechThread.IsSpeaking) and (FAutoSpeechStartingTime < Now) then
  begin
    FormCaption.Status := nil;
  end;
end;

procedure TFormMainTweetVoice.TrayIconMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  if (mbLeft = Button) then
  begin
    ShowWindowAsync(Handle, SW_RESTORE);
    SetForeGroundWindow(Handle);
  end;
end;

procedure TFormMainTweetVoice.UpdateCaption;
begin
  FormCaption.UpdateUI;
end;

procedure TFormMainTweetVoice.UpdateStatusPanel0;
var
  Count: Integer;
begin
  Count := FStatusesTabs.UpdatingCount;
  if (Count = 0) then
  begin
    StatusBar.Panels[0].Text := 'S' + IntToStr(VirtualTreeView.RootNodeCount) + '';
  end
  else
  begin
    StatusBar.Panels[0].Text := Format('ʐM(%d)', [Count]);
  end;
end;

procedure TFormMainTweetVoice.UpdateStatusPanel1;
begin
  StatusBar.Panels[1].Text := FStatusesTabs[TabControl.TabIndex].StatusPanelText;
end;

procedure TFormMainTweetVoice.UpdateTabs(ARecreate: Boolean);
var
  tab: TXMLStatusesTab;
  i: Integer;
begin
  if (ARecreate) or (TabControl.Tabs.Count <> FStatusesTabs.Items.Count) then
  begin
    TabControl.Tabs.BeginUpdate;
    TabControl.Tabs.Clear;
    for tab in FStatusesTabs.Items do
    begin
      TabControl.Tabs.Add(tab.DisplayName);
    end;
    TabControl.Tabs.EndUpdate;
  end
  else
  begin
    i := 0;
    for tab in FStatusesTabs.Items do
    begin
      TabControl.Tabs[i] := tab.DisplayName;
      Inc(i);
    end;
  end;
end;

procedure TFormMainTweetVoice.UpdateUI;
var
  nodeSelected: Boolean;
  saved: Boolean;
  search: TXMLSearch;
  panelPostStatusVisible: Boolean;
  Status: TXMLStatus;
  dmValid: Boolean;
  User: TXMLUser;
begin
  nodeSelected := VirtualTreeView.SelectedCount <> 0;

  ActionToggleRelativeDateString.Checked := UserConfig.RelativeDateString;
  ActionMuteSpeech.Checked := UserConfig.MuteSpeech;
  ActionPauseSpeech.Checked := UserConfig.PauseSpeech;
  ActionAutoRefresh.Checked := UserConfig.AutoRefresh;
  ActionCloseTab.Enabled := FStatusesTabs[TabControl.TabIndex].CanClose;
  ActionAutoRequestOlderStatuses.Checked := UserConfig.AutoRequestOlderStatuses;
  ActionCreateFavorites.Enabled := nodeSelected and (FStatusesTabs[TabControl.TabIndex].TabType <> ttFavorites) and
    (FStatusesTabs[TabControl.TabIndex].TabType <> ttDirectMessages) and
    (FStatusesTabs[TabControl.TabIndex].TabType <> ttSentDirectMessages);
  ActionDestroyFavorites.Enabled := nodeSelected and (FStatusesTabs[TabControl.TabIndex].TabType = ttFavorites);
  // := FStatusesTabs[TabControl.TabIndex].TabType = ttSearch;
  ActionCreateFriendship.Enabled := nodeSelected;
  ActionDestroyFriendship.Enabled := nodeSelected;
  // ActionCopyStatusToClipboard.Enabled := nodeSelected;
  ActionCopyStatusAllToClipboard.Enabled := nodeSelected;
  ActionUpdateSetRead.Enabled := nodeSelected;
  ActionUpdateSetUnread.Enabled := nodeSelected;
  ActionReply.Enabled := nodeSelected;
  ActionRetweet.Enabled := nodeSelected;
  ActionQuoteTweet.Enabled := nodeSelected;

  ActionSetCaptionNormal.Checked := (UserConfig.CaptionType = ctCaptionNormal);
  ActionSetCaptionWindow.Checked := (UserConfig.CaptionType = ctCaptionWindow);
  ActionSetBalloon.Checked := (UserConfig.CaptionType = ctBalloon);
  ActionShortenURL.Enabled := MemoPostMessage.Text <> '';
  ActionStatusViewSingleLine.Checked := UserConfig.StatusViewType = svSingleLine;
  ActionStatusViewNormal.Checked := UserConfig.StatusViewType = svNormal;
  ActionStatusViewJustFit.Checked := UserConfig.StatusViewType = svJustFit;
  if (FPostDirectMessage) then
  begin
    dmValid := false;
    User := XMLUserManager.GetUser(ComboBoxPostUserNames.Text);
    if Assigned(User) and (User.FollowingIndex = 3) then
    begin
      dmValid := true;
      LabelInReplyTo.Caption := User.Name;
    end
    else
    begin
      LabelInReplyTo.Caption := '';
    end;
  end
  else
  begin
    dmValid := true;
  end;

  ButtonPost.Enabled := (MemoPostMessage.Text <> '') and dmValid;
  panelPostStatusVisible := false;
  if (FPostDirectMessage) then
  begin
    ButtonPost.ImageIndex := -1;
    ComboBoxPostUserNames.Enabled := true;
    panelPostStatusVisible := true;
    LabelReply.Caption := 'DM';
  end
  else if (FReplyStatusID = 0) then
  begin
    ButtonPost.ImageIndex := -1;
  end
  else
  begin
    ComboBoxPostUserNames.Enabled := false;
    ButtonPost.ImageIndex := 14;
    panelPostStatusVisible := true;
    LabelReply.Caption := 'ԐM';
    Status := XMLStatusManager.GetStatus(FReplyStatusID);
    if Assigned(Status) then
    begin
      LabelInReplyTo.Caption := Status.Text;
      ComboBoxPostUserNames.Text := Status.User.ScreenName;
    end
    else
    begin
      LabelInReplyTo.Caption := '';
    end;
  end;

  PanelPostStatus.Visible := panelPostStatusVisible;
  PanelPost.Visible := ActionShowPanelPost.Checked;
  if (FStatusesTabs[TabControl.TabIndex].TabType = ttSearch) then
  begin
    saved := false;
    for search in FSavedSearches do
    begin
      if (CompareText(search.Query, FStatusesTabs[TabControl.TabIndex].SearchWord) = 0) then
      begin
        saved := true;
        break;
      end;
    end;
    ActionCreateSavedSearch.Enabled := Not saved;
    ActionDestroySavedSearch.Enabled := saved;
  end
  else
  begin
    ActionCreateSavedSearch.Enabled := false;
    ActionDestroySavedSearch.Enabled := false;
  end;

  ActionFindNext.Enabled := PanelFind.Visible and (ComboBoxFindWord.Text <> '');
  ActionFindPrevious.Enabled := PanelFind.Visible and (ComboBoxFindWord.Text <> '');

  case UserConfig.StatusViewType of
    svNormal:
      VirtualTreeView.DefaultNodeHeight := MIN_NODE_HEIGHT;
    svJustFit:
      VirtualTreeView.DefaultNodeHeight := VirtualTreeView.Canvas.TextHeight(' ') + 4;
    svSingleLine:
      VirtualTreeView.DefaultNodeHeight := VirtualTreeView.Canvas.TextHeight(' ') + 4;
  end;
end;

procedure TFormMainTweetVoice.UpdateVirtualTreeView;
var
  tab: TXMLStatusesTab;
  Status: TXMLStatus;
  BottomNode: PVirtualNode;
  Node: PVirtualNode;
begin
  BottomNode := nil;
  ClearTreeNodes;
  VirtualTreeView.BeginUpdate;
  try
    tab := FStatusesTabs[TabControl.TabIndex];
    if (tab.TabType = ttDirectMessages) or (tab.TabType = ttSentDirectMessages) then
    begin
      VirtualTreeView.Header.Columns[4].Text := 'M惆[U';
    end
    else
    begin
      VirtualTreeView.Header.Columns[4].Text := 'M';
    end;

    for Status in tab.Statuses do
    begin
      Node := AddVirtualTreeViewNode(Status);
      if (Status = tab.BottomStatus) then
      begin
        BottomNode := Node;
      end;
    end;
  finally
    VirtualTreeView.EndUpdate;
  end;
  if Assigned(BottomNode) then
  begin
    VirtualTreeView.ScrollIntoView(BottomNode, false);
  end;
  UpdateStatusPanel1;
end;

procedure TFormMainTweetVoice.VirtualTreeViewChange(Sender: TBaseVirtualTree; Node: PVirtualNode);
var
  dataPtr: PTreeData;
begin
  UpdateUI;
  if Assigned(FSelectedNode) and (Not VirtualTreeView.Selected[FSelectedNode]) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(FSelectedNode);
    if Assigned(dataPtr.TextRectView) then
    begin
      dataPtr.TextRectView.Canvas := VirtualTreeView.Canvas;
      dataPtr.TextRectView.ClearSelection;
      FSelectedNode := nil;
    end;
  end;
end;

procedure TFormMainTweetVoice.VirtualTreeViewColumnResize(Sender: TVTHeader; Column: TColumnIndex);
begin
  VirtualTreeView.ReinitChildren(nil, false);
end;

procedure TFormMainTweetVoice.VirtualTreeViewCompareNodes(Sender: TBaseVirtualTree; Node1, Node2: PVirtualNode;
  Column: TColumnIndex; var Result: Integer);
var
  data1Ptr: PTreeData;
  data2Ptr: PTreeData;
  status1: TXMLStatus;
  status2: TXMLStatus;
begin
  data1Ptr := VirtualTreeView.GetNodeData(Node1);
  data2Ptr := VirtualTreeView.GetNodeData(Node2);
  status1 := data1Ptr.Status;
  status2 := data2Ptr.Status;

  case Column of
    - 1:
      begin
        if (status1.ID = status2.ID) then
        begin
          Result := 0;
        end
        else if (status1.ID > status2.ID) then
        begin
          Result := 1;
        end
        else
        begin
          Result := -1;
        end;
      end;
    0:
      Result := Utils.CompareString(status1.User.ProfileImageUrl, status2.User.ProfileImageUrl);
    1:
      Result := Utils.CompareString(status1.User.Name, status2.User.Name);
    2:
      Result := Utils.CompareString(status1.Text, status2.Text);
    3:
      Result := CompareDateTime(status1.CreatedAt, status2.CreatedAt);
    4:
      Result := Utils.CompareString(status1.Source.Name, status2.Source.Name);
    5:
      Result := Integer(status1.IsRead) - Integer(status2.IsRead);
    6:
      Result := Integer(status1.Favorited) - Integer(status2.Favorited);
    7:
      Result := status1.User.FollowingIndex - status2.User.FollowingIndex;
    8:
      Result := status1.GetIconForSorting - status2.GetIconForSorting;

  end;

end;

procedure TFormMainTweetVoice.VirtualTreeViewDrawText(Sender: TBaseVirtualTree; TargetCanvas: TCanvas;
  Node: PVirtualNode; Column: TColumnIndex; const Text: string; const CellRect: TRect; var DefaultDraw: Boolean);
var
  s: WideString;

  Rect: TRect;
  focusRect: TRect;
  dataPtr: PTreeData;
  ForeColor: TColor;
  BackColor: TColor;
  BackColor2: TColor;
  BF: TBlendfunction;
  alpha: Integer;
  picture: TPicture;
  Vertices: Array [0 .. 1] of TTriVertex;
  GradientRect: TGradientRect;
  Status: TXMLStatus;
  imageOffsetY, Y, h: Integer;
  isSelected: Boolean;
begin
  dataPtr := VirtualTreeView.GetNodeData(Node);
  Status := dataPtr.Status;
  if Assigned(Status.RetweetedStatus) then
  begin
    Status := Status.RetweetedStatus;
  end;

  imageOffsetY := 2;
  Rect := CellRect;
  if (VirtualTreeView.Selected[Node]) then
  begin
    ForeColor := clWhite;
    BackColor := RGB(51, 153, 255);
    BackColor2 := RGB(51, 153, 255);
    isSelected := true;
  end
  else
  begin
    ForeColor := Status.User.GetProfileTextColor;
    BackColor := Status.User.GetProfileSidebarFillColor;
    BackColor2 := Status.User.GetProfileSidebarFillColor2;
    isSelected := false;
    if (UserConfig.StatusViewType = svSingleLine) then
    begin
      imageOffsetY := 0;
    end
    else if (UserConfig.StatusViewType = svJustFit) and ((CellRect.Bottom - CellRect.Top) < 48) then
    begin
      imageOffsetY := 0;
    end;
  end;

  TargetCanvas.Font.Color := ForeColor;
  Vertices[0].X := Rect.Left;
  Vertices[0].Y := Rect.Top;
  Vertices[0].Red := GetRValue(BackColor) shl 8;
  Vertices[0].Green := GetGValue(BackColor) shl 8;
  Vertices[0].Blue := GetBValue(BackColor) shl 8;
  Vertices[0].alpha := 0;

  Vertices[1].X := Rect.Right;
  Vertices[1].Y := Rect.Bottom;
  Vertices[1].Red := GetRValue(BackColor2) shl 8;
  Vertices[1].Green := GetGValue(BackColor2) shl 8;
  Vertices[1].Blue := GetBValue(BackColor2) shl 8;
  Vertices[1].alpha := 0;

  GradientRect.UpperLeft := 0;
  GradientRect.LowerRight := 1;

  Windows.GradientFill(TargetCanvas.Handle, @Vertices[0], 2, @GradientRect, 1, GRADIENT_FILL_RECT_V);
  // TargetCanvas.FillRect(Rect);
  // TargetCanvas.Brush.Style := bsSolid; ;
  TargetCanvas.Brush.Style := bsClear;

  if (Column = 0) then
  begin
    if Assigned(Status.User.ProfileImage) then
    begin
      Y := Rect.Top;
      if (imageOffsetY = 0) then
      begin
        h := CellRect.Bottom - CellRect.Top;
        Y := Y + ((h - 48) div 2);
      end;
      TargetCanvas.Draw(Rect.Left, Y, Status.User.ProfileImage);
    end;
  end
  else if (Column = 1) then
  begin
    dataPtr.UserRectView.Canvas := TargetCanvas;
    dataPtr.UserRectView.Draw(CellRect);
  end
  else if (Column = 2) then
  begin
    dataPtr.TextRectView.Canvas := TargetCanvas;
    dataPtr.TextRectView.Draw(CellRect);
  end
  else if (Column = 4) then
  begin
    dataPtr.SourceRectView.Canvas := TargetCanvas;
    dataPtr.SourceRectView.Draw(CellRect);
  end
  else if (Column = 5) then
  begin
    if (Status.IsRead) then
    begin
      if (isSelected) then
        TargetCanvas.Draw(Rect.Left + 2, Rect.Top + imageOffsetY, ImageReadX.picture.Graphic)
      else
        TargetCanvas.Draw(Rect.Left + 2, Rect.Top + imageOffsetY, ImageRead.picture.Graphic);
    end
    else
    begin
      TargetCanvas.Draw(Rect.Left + 2, Rect.Top + imageOffsetY, ImageUnread.picture.Graphic);
    end;
  end
  else if (Column = 6) then
  begin
    if (Status.Favorited) then
    begin
      if (isSelected) then
        TargetCanvas.Draw(Rect.Left + 2, Rect.Top + imageOffsetY, ImageFavoritedX.picture.Graphic)
      else
        TargetCanvas.Draw(Rect.Left + 2, Rect.Top + imageOffsetY, ImageFavorited.picture.Graphic);
    end
    else
    begin
      TargetCanvas.Draw(Rect.Left + 2, Rect.Top + imageOffsetY, ImageNoFavorited.picture.Graphic);
    end;
  end
  else if (Column = 7) then
  begin
    picture := ImageNoFollow.picture;
    if (isSelected) then
    begin
      case Status.User.FollowingIndex of
        1:
          picture := ImageFollowedByMeX.picture;
        2:
          picture := ImageFollowingMeX.picture;
        3:
          picture := ImageFollowingEachOtherX.picture;
      end;
    end
    else
    begin
      case Status.User.FollowingIndex of
        1:
          picture := ImageFollowedByMe.picture;
        2:
          picture := ImageFollowingMe.picture;
        3:
          picture := ImageFollowingEachOther.picture;
      end;
    end;
    if Assigned(picture) then
    begin
      TargetCanvas.Draw(Rect.Left + 2, Rect.Top + imageOffsetY, picture.Graphic);
    end;
  end
  else if (Column = 8) then
  begin
    if (Status.InReplyToStatusID <> 0) then
    begin
      TargetCanvas.Draw(Rect.Left, Rect.Top, ImageReply.picture.Graphic);
    end
    else if (dataPtr.Status.RetweetedStatusID > 0) then
    begin
      TargetCanvas.Draw(Rect.Left, Rect.Top, ImageRetweet.picture.Graphic);
    end;
  end
  else

  begin
    case Column of
      3:
        s := GetDateString(dataPtr.Status.LocalTimeCreatedAt, 'ja');
    end;

    if (Column = 1) then
    begin
      TargetCanvas.Font.Style := [fsBold];
    end;

    Rect.Top := Rect.Top + NODE_TOP_MARGIN;
    Rect.Left := Rect.Left + NODE_LEFT_MARGIN;
    Windows.DrawTextW(TargetCanvas.Handle, PWideChar(s), -1, Rect, DT_WORDBREAK or DT_NOPREFIX);
  end;

  if (FBlinkAlpha > 200) then
  begin
    alpha := 400 - FBlinkAlpha;
  end
  else
  begin
    alpha := FBlinkAlpha;
  end;
  if (FSpeechThread.IsSpeaking(dataPtr.Status)) then
  begin
    // FɃtF[h
    BF.Blendop := AC_SRC_OVER;
    BF.BlendFlags := 0;
    BF.SourceconstantAlpha := alpha; // ߓx 50ɐݒ (2550 x)
    BF.Alphaformat := 0;

    Windows.AlphaBlend(TargetCanvas.Handle, CellRect.Left, CellRect.Top, CellRect.Right - CellRect.Left,
      CellRect.Bottom - CellRect.Top, FWhiteBitmap.Canvas.Handle, 0, 0, FWhiteBitmap.Width, FWhiteBitmap.Height,
      BF);
  end
  else if (dataPtr.Status.ID = FStatusesTabs[TabControl.TabIndex].LastSpeechStatusID) and (Column <> 0) then
  begin
    TargetCanvas.Pen.Width := 3;
    TargetCanvas.Pen.Mode := pmXor;
    TargetCanvas.Pen.Color := RGB(255, 255, 255);
    focusRect.Left := CellRect.Left;
    focusRect.Top := CellRect.Top;
    focusRect.Right := CellRect.Right;
    focusRect.Bottom := CellRect.Bottom;

    // TargetCanvas.DrawFocusRect(focusRect);
    TargetCanvas.MoveTo(CellRect.Left, CellRect.Top + 1);
    TargetCanvas.LineTo(CellRect.Right, CellRect.Top + 1);
  end
  else
  begin
    TargetCanvas.Pen.Width := 1;
    TargetCanvas.Pen.Mode := pmCopy;
    TargetCanvas.Pen.Color := RGB(128, 128, 128);
    focusRect.Left := CellRect.Left;
    focusRect.Top := CellRect.Top;
    focusRect.Right := CellRect.Right;
    focusRect.Bottom := CellRect.Bottom;

    TargetCanvas.MoveTo(CellRect.Left, CellRect.Top);
    TargetCanvas.LineTo(CellRect.Right, CellRect.Top);
  end;

  if (VirtualTreeView.Selected[Node]) then
  begin
    // ㉺ɐԂ
    TargetCanvas.Pen.Width := 2;
    TargetCanvas.Pen.Color := clRed;
    TargetCanvas.Pen.Mode := pmCopy;
    TargetCanvas.Pen.Style := psSolid;
    TargetCanvas.MoveTo(CellRect.Left, CellRect.Top + 1);
    TargetCanvas.LineTo(CellRect.Right, CellRect.Top + 1);
    TargetCanvas.MoveTo(CellRect.Left, CellRect.Bottom - 1);
    TargetCanvas.LineTo(CellRect.Right, CellRect.Bottom - 1);

  end;

  DefaultDraw := false;
end;


procedure TFormMainTweetVoice.VirtualTreeViewHeaderClick(Sender: TVTHeader; Column: TColumnIndex; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Column >= 0) then
  begin
    if (VirtualTreeView.Header.SortColumn = Column) then
    begin
      if (VirtualTreeView.Header.SortDirection = sdDescending) then
      begin
        VirtualTreeView.Header.SortDirection := sdAscending;
      end
      else
      begin
        VirtualTreeView.Header.SortColumn := -1;
        VirtualTreeView.Header.SortDirection := sdDescending;
      end;
    end
    else
    begin
      VirtualTreeView.Header.SortColumn := Column;
      VirtualTreeView.Header.SortDirection := sdDescending;
    end;
    VirtualTreeView.Sort(nil, VirtualTreeView.Header.SortColumn, VirtualTreeView.Header.SortDirection);
  end;

end;

procedure TFormMainTweetVoice.VirtualTreeViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  OldNode, Node: PVirtualNode;
  dataPtr: PTreeData;
  User: TXMLUser;
begin
  if (Key = VK_RIGHT) then
  begin
    Node := GetSelectedNode;
    OldNode := Node;
    if Assigned(Node) then
    begin
      dataPtr := VirtualTreeView.GetNodeData(Node);
      User := dataPtr.Status.GetRetweetedStatus.User;
      Node := Node.NextSibling;
      while (Assigned(Node)) do
      begin
        dataPtr := VirtualTreeView.GetNodeData(Node);
        if (User = dataPtr.Status.GetRetweetedStatus.User) then
        begin
          VirtualTreeView.ClearSelection;
          VirtualTreeView.Selected[Node] := true;
          VirtualTreeView.ReinitNode(OldNode, false);
          VirtualTreeView.ScrollIntoView(Node, false);
          break;
        end;
        Node := Node.NextSibling;
      end;
    end;
    Key := 0;
  end;
  if (Key = VK_LEFT) then
  begin
    Node := GetSelectedNode;
    OldNode := Node;
    if Assigned(Node) then
    begin
      dataPtr := VirtualTreeView.GetNodeData(Node);
      User := dataPtr.Status.GetRetweetedStatus.User;
      Node := Node.PrevSibling;
      while (Assigned(Node)) do
      begin
        dataPtr := VirtualTreeView.GetNodeData(Node);
        if (User = dataPtr.Status.GetRetweetedStatus.User) then
        begin
          VirtualTreeView.ClearSelection;
          VirtualTreeView.Selected[Node] := true;
          VirtualTreeView.ReinitNode(OldNode, false);
          VirtualTreeView.ScrollIntoView(Node, false);
          break;
        end;
        Node := Node.PrevSibling;
      end;
    end;
    Key := 0;
  end;

end;

procedure TFormMainTweetVoice.VirtualTreeViewMeasureItem(Sender: TBaseVirtualTree; TargetCanvas: TCanvas;
  Node: PVirtualNode; var NodeHeight: Integer);
var
  dataPtr: PTreeData;
  columnW: Integer;
  minNodeHeight: Integer;
begin
  try
    Assert(Node <> nil);

    dataPtr := VirtualTreeView.GetNodeData(Node);
    columnW := VirtualTreeView.Header.Columns[2].Width;

    Assert(dataPtr <> nil);
    Assert(dataPtr.TextRectView <> nil);
    Assert(dataPtr.Status <> nil);

    TargetCanvas.Font.Name := UserConfig.ListViewFont.FontName;
    TargetCanvas.Font.Size := UserConfig.ListViewFont.FontSize;
    dataPtr.TextRectView.Canvas := TargetCanvas;
    dataPtr.TextRectView.ArrangeLayout(columnW);

    dataPtr.UserRectView.Canvas := TargetCanvas;
    dataPtr.UserRectView.ArrangeLayout(VirtualTreeView.Header.Columns[1].Width);

    columnW := VirtualTreeView.Header.Columns[4].Width;
    dataPtr.SourceRectView.Canvas := TargetCanvas;
    dataPtr.SourceRectView.ArrangeLayout(columnW);

    if (VirtualTreeView.Selected[Node]) then
    begin
      minNodeHeight := MIN_NODE_HEIGHT;
    end
    else
    begin
      minNodeHeight := VirtualTreeView.DefaultNodeHeight;
    end;

    if (VirtualTreeView.Selected[Node]) or (UserConfig.StatusViewType <> svSingleLine) then
    begin
      NodeHeight := dataPtr.TextRectView.Height;

      if (NodeHeight < minNodeHeight) then
      begin
        NodeHeight := minNodeHeight;
      end;
    end
    else
    begin
      NodeHeight := TargetCanvas.TextHeight(' ') + 4;
    end;
  except
    on E: Exception do
    begin
      FormLogs.AddLogText(E.Message, ClassName);
    end;
  end;
end;

procedure TFormMainTweetVoice.VirtualTreeViewMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  dataPtr: PTreeData;
  Node: PVirtualNode;
  Column: TVirtualTreeColumn;
  i: Integer;
  r: TRect;
  // s: string;
  // f: TFont;
  rx, ry: Integer;
begin
  Node := VirtualTreeView.GetNodeAt(X, Y);
  if Assigned(Node) then
  begin
    // f := VirtualTreeView.Font;
    dataPtr := VirtualTreeView.GetNodeData(Node);
    for i := 0 to VirtualTreeView.Header.Columns.Count - 1 do
    begin
      Column := VirtualTreeView.Header.Columns[i];
      // VirtualTreeView.GetTextInfo(Node, i, f, r, s);
      r := VirtualTreeView.GetDisplayRect(Node, i, false);
      if (r.Left <= X) and (r.Left + Column.Width > X) then
      begin
        rx := X - r.Left;
        ry := Y - r.Top;
        // + VirtualTreeView.Header.Height;
        if (i = 4) then
        begin
          dataPtr.SourceRectView.OnMouseDown(rx, ry, Button, Shift);
          break;
        end
        else if (i = 2) then
        begin
          dataPtr.TextRectView.Canvas := VirtualTreeView.Canvas;
          dataPtr.TextRectView.OnMouseDown(rx, ry, Button, Shift);
          VirtualTreeView.RepaintNode(Node);
          break;
        end
        else if (i = 1) then
        begin
          dataPtr.UserRectView.OnMouseDown(rx, ry, Button, Shift);
          break;
        end;

      end;
    end;
  end;
end;

procedure TFormMainTweetVoice.VirtualTreeViewMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  dataPtr: PTreeData;
  Node: PVirtualNode;
  Column: TVirtualTreeColumn;
  i: Integer;
  r: TRect;
  rx, ry: Integer;
begin
  VirtualTreeView.Cursor := crDefault;
  Node := VirtualTreeView.GetNodeAt(X, Y);
  if Assigned(Node) then
  begin
    // f := VirtualTreeView.Font;
    dataPtr := VirtualTreeView.GetNodeData(Node);
    for i := 0 to VirtualTreeView.Header.Columns.Count - 1 do
    begin
      Column := VirtualTreeView.Header.Columns[i];
      r := VirtualTreeView.GetDisplayRect(Node, i, false);
      rx := X - r.Left;
      ry := Y - r.Top;

      if (r.Left <= X) and (r.Left + Column.Width > X) then
      begin
        if (i = 4) then
        begin
          VirtualTreeView.Cursor := dataPtr.SourceRectView.GetCursor(rx, ry);
          break;
        end
        else if (i = 2) then
        begin
          VirtualTreeView.Cursor := dataPtr.TextRectView.GetCursor(rx, ry);
          break;
        end
        else if (i = 1) then
        begin
          VirtualTreeView.Cursor := dataPtr.UserRectView.GetCursor(rx, ry);
          break;
        end;
      end;
    end;

    // Utils.OutputDebugString(Format('rtx=%4d rty=%4d', [rtx, rty]));

    r := VirtualTreeView.GetDisplayRect(Node, 2, false);
    rx := X - r.Left;
    ry := Y - r.Top;

    dataPtr.TextRectView.Canvas := VirtualTreeView.Canvas;
    if (dataPtr.TextRectView.OnMouseMove(rx, ry, Shift)) then
    begin
      FSelectedNode := Node;
    end;

    VirtualTreeView.RepaintNode(Node);
  end;
end;

procedure TFormMainTweetVoice.VirtualTreeViewMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  dataPtr: PTreeData;
  Node: PVirtualNode;
  // Column: TVirtualTreeColumn;
  i: Integer;
  r: TRect;
  rx, ry: Integer;
begin
  Node := VirtualTreeView.GetNodeAt(X, Y);
  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);
    for i := 0 to VirtualTreeView.Header.Columns.Count - 1 do
    begin
      // Column := VirtualTreeView.Header.Columns[i];
      r := VirtualTreeView.GetDisplayRect(Node, i, false);
      rx := X - r.Left;
      ry := Y - r.Top;

      if (i = 4) then
      begin
        // dataPtr.SourceRectView.OnMouseUp(rx, ry);
      end
      else if (i = 2) then
      begin
        dataPtr.TextRectView.OnMouseUp(rx, ry, Button, Shift);
        VirtualTreeView.RepaintNode(Node);
      end
      else if (i = 1) then
      begin
        // dataPtr.UserRectView.OnMouseUp(rx, ry);
      end;
    end;
  end;
end;

procedure TFormMainTweetVoice.VirtualTreeViewScroll(Sender: TBaseVirtualTree; DeltaX, DeltaY: Integer);
var
  Node: PVirtualNode;
  dataPtr: PTreeData;
  tab: TXMLStatusesTab;
  v: Boolean;
begin
  Node := VirtualTreeView.BottomNode;
  if Assigned(Node) then
  begin
    dataPtr := VirtualTreeView.GetNodeData(Node);

    // FormLogs.AddLogText(dataPtr.Status.Text, Self.ClassName);
    tab := FStatusesTabs[TabControl.TabIndex];
    tab.BottomStatus := dataPtr.Status;
    if (UserConfig.AutoRequestOlderStatuses) and (VirtualTreeView.Header.SortColumn < 0) then
    begin
      Node := VirtualTreeView.RootNode.LastChild;

      v := VirtualTreeView.BottomNode = Node;
      // v := VirtualTreeView.GetEffectivelyVisible(Node);

      if (v) then
      begin
        tab.RequestOlderStatuses(Self, FCommunicator);
        UpdateStatusPanel0;
      end;
    end;
  end;
end;

procedure TFormMainTweetVoice.WMMousewheel(var Msg: TMessage);
var
  pt: TPoint;
  Control: TControl;
begin
  pt.X := Word(Msg.lParam);
  pt.Y := HiWord(Msg.lParam);
  Control := FindVCLWindow(pt);
  // Control := ControlAtPos(ScreenToClient(SmallPointToPoint(TWMMouseWheel(Msg).Pos)), False, True, True);
  if Assigned(Control) then
  begin
    if Control.Perform(CM_MOUSEWHEEL, Msg.WParam, Msg.lParam) = 0 then
      Control.DefaultHandler(Msg);
  end
  else
    inherited MouseWheelHandler(Msg);
end;

{
  procedure TFormMainTweetVoice.WMSysCommand(var Msg: TWMSysCommand);
  begin
  case Msg.CmdType and $FFF0 of
  SC_MINIMIZE:
  Self.Hide;
  else
  inherited;
  end;
  end;
  }

end.
