unit tvFormPinCode;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls;

type
  TFormPinCode = class(TForm)
    Panel1: TPanel;
    WebBrowser: TWebBrowser;
    Label1: TLabel;
    Label2: TLabel;
    EditPinCode: TEdit;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    procedure ButtonOKClick(Sender: TObject);
    procedure EditPinCodeChange(Sender: TObject);
  private
    FPinCode: string;
    { Private 錾}
    procedure UpdateUI;
    procedure SetPinCode(const Value: string);
  public
    { Public 錾 }

    procedure Initialize(AURL: string);
    property PinCode: string read FPinCode write SetPinCode;
  end;

var
  FormPinCode: TFormPinCode;

implementation

{$R *.dfm}

procedure TFormPinCode.ButtonOKClick(Sender: TObject);
begin
  FPinCode := EditPinCode.Text;
  Close;
  ModalResult := mrOK;
end;

procedure TFormPinCode.EditPinCodeChange(Sender: TObject);
begin
  UpdateUI;
end;

procedure TFormPinCode.Initialize(AURL: string);
begin
  EditPinCode.Text := '';
  UpdateUI;
  WebBrowser.Navigate(AURL);
end;

procedure TFormPinCode.SetPinCode(const Value: string);
begin
end;

procedure TFormPinCode.UpdateUI;
begin
  ButtonOK.Enabled :=  Length(EditPinCode.Text) <> 0;

end;

end.
